<?php
include 'S_Client_security.php';
?>

<?php
session_start();
// Získání ID uživatele z relace
$user_id = $_SESSION['user_id'];

$servername = '10.79.157.1:3306';
$username = 'root';
$password = '*****';
$dbname = 'moto_dilna_db';

try {
    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    // Dotaz pro načtení údajů přihlášeného uživatele
    $stmt = $conn->prepare("SELECT Osobni_udaje.jmeno,  Osobni_udaje.prijmeni,  Osobni_udaje.datumNarozeni,  Osobni_udaje.email,  Osobni_udaje.telefon
    FROM Klient
    JOIN Osobni_udaje ON Klient.Osobni_udaje_idOsobni_udaje = Osobni_udaje.idOsobni_udaje
    WHERE Klient.idKlient = :user_id");
    $stmt->bindParam(':user_id', $user_id);
    $stmt->execute();
    $row = $stmt->fetch(PDO::FETCH_ASSOC);

    // Uložení údajů do proměnných
    $jmeno = $row['jmeno'];
    $prijmeni = $row['prijmeni'];
    $email = $row['email'];

    // IF po odeslání formuláře pro přidání motocyklu
    if ($_SERVER["REQUEST_METHOD"] == "POST") {
        // Získání dat z formuláře
        $znacka_id = $_POST['znacka_id'];
        $model = $_POST['model'];
        $rokVyroby = $_POST['rokVyroby'];
        $VIN = $_POST['vin'];
        $platnostSTK = $_POST['platnostSTK'];
        $stavKM = $_POST['pocetKM'];

        // Vložení údajů do databáze
        $stmt = $conn->prepare("INSERT INTO Motocykl (Znacka_idZnacka, model, rokVyroby, vin, platnostSTK, pocetKM, Klient_idKlient, foto) 
                                VALUES (:znacka_id, :model, :rokVyroby, :vin, :platnostSTK, :pocetKM, :user_id, 'https://latertakephoto.cz')");
        // Provázání hodnot
        $stmt->bindParam(':znacka_id', $znacka_id);
        $stmt->bindParam(':model', $model);
        $stmt->bindParam(':rokVyroby', $rokVyroby);
        $stmt->bindParam(':vin', $VIN);
        $stmt->bindParam(':platnostSTK', $platnostSTK);
        $stmt->bindParam(':pocetKM', $stavKM);
        $stmt->bindParam(':user_id', $user_id);
        $stmt->execute();

        echo "<script>alert('Motocykl byl úspěšně přidán.');</script>";
        echo "<script>setTimeout(function(){ window.location.href = 'C_Client.php'; }, 3000);</script>";
    }
} catch(PDOException $e) {
    echo "Připojení k databázi selhalo: " . $e->getMessage();
}
?>

<!DOCTYPE html>
<html lang="cs">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Přidání motocyklu</title>
    <link rel="icon" type="image/png" href="Photo.png">
    <link href="scss.css" rel="stylesheet" />
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>
<body>
    <div class="container-fluid">
        <div class="row">
            <div class="col-lg-2 col-md-3 purple-bar">
                <div class="button-container">
                    <br>
                    <button type="button" class="btn btn-primary mb-3" onclick="window.history.back();">Zpět</button>
                </div>
            </div>
            <div class="col-lg-8 col-md-8">
                <div class="middle-bar">
                    <div class="enter">
                        <div class="centered-text">
                            <div class="content">
                                <h1><b>Přidání motocyklu</b></h1>
                            </div>
                        </div>
                        <div class="custom-frame">  
                            <form method="post">
                                <div class="form-group row">
                                <label for="znacka_id" class="col-sm-2 col-form-label"><b>Značka:</b></label>
                                <div class="col-sm-10">
                                    <select id="znacka_id" name="znacka_id" class="form-control">
                                        <?php
                                        $stmt = $conn->query("SELECT * FROM Znacka");
                                        while ($row = $stmt->fetch()) {
                                            echo "<option value='".$row['idZnacka']."'>".$row['nazev']."</option>";
                                        }
                                        ?>
                                    </select>
                                </div>                          
                            </div>
                            <div class="form-group row">
                                <label for="model" class="col-sm-2 col-form-label"><b>Model:</b></label>
                                <div class="col-sm-10">
                                    <input type="text" id="model" name="model" class="form-control" required>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="rokVyroby" class="col-sm-2 col-form-label"><b>Rok výroby:</b></label>
                                <div class="col-sm-10">
                                    <input type="text" id="rokVyroby" name="rokVyroby" class="form-control" required pattern="[0-9]{4}">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="VIN" class="col-sm-2 col-form-label"><b>VIN:</b></label>
                                <div class="col-sm-10">
                                    <input type="text" id="VIN" name="vin" class="form-control" maxlength="17" minlength="17" required>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label for="platnostSTK" class="col-sm-2 col-form-label"><b>Platnost STK:</b></label>
                                <div class="col-sm-10">
                                    <input type="text" id="platnostSTK" name="platnostSTK" class="form-control" placeholder="rrrr-mm-dd" required pattern="\d{4}-\d{2}-\d{2}" oninput="formatDateInput(event)">
                                </div>
                            </div>
                            <script>
                            //Formátování datumu
                            function formatDateInput(event) {
                                let input = event.target;
                                let value = input.value.replace(/\D/g, '');
                                if (value.length > 8) {
                                    value = value.slice(0, 8);
                                }
                                let formattedValue = '';
                                for (let i = 0; i < value.length; i++) {
                                    if (i === 4 || i === 6) {
                                        formattedValue += '-';
                                    }
                                    formattedValue += value[i];
                                }
                                input.value = formattedValue;
                            }
                            </script>
                            <div class="form-group row">
                                <label for="stavKM" class="col-sm-2 col-form-label"><b>Stav KM:</b></label>
                                <div class="col-sm-10">
                                    <input type="text" id="stavKM" name="pocetKM" class="form-control" required pattern="[0-9]+">
                                </div>
                            </div>
                            <div class="centered-text">
                             <button type="submit" class="btn btn-primary mb-3"><b>Přidat motocykl</b></button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
        <div class="col-lg-2 col-md-3 purple-bar">
                <div class="button-container">
                    <br>
                    <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='C_Client.php';">Domov</button>
                </div>
            </div>
        </div>
    </div>
    <script type="text/javascript">
    var Tawk_API=Tawk_API||{}, Tawk_LoadStart=new Date();
    // Předdefinování atributů a funkcí
    window.Tawk_API = window.Tawk_API || {};
    window.Tawk_API.onLoad = function() {
        Tawk_API.setAttributes({
            'name' : '<?php echo $jmeno . " " . $prijmeni; ?>',
            'email' : '<?php echo $email; ?>',
        }, function(error){});

        // Přidání události nebo poznámky
        Tawk_API.addEvent('Informace o klientovi', {
            'Jméno': '<?php echo $jmeno; ?>',
            'Příjmení': '<?php echo $prijmeni; ?>',
            'E-mail': '<?php echo $email; ?>',
        }, function(error, success){});
    };
    // Načtení skriptu Tawk.to
    (function(){
        var s1=document.createElement("script"),s0=document.getElementsByTagName("script")[0];
        s1.async=true;
        s1.src='https://embed.tawk.to/66009a091ec1082f04dab4dd/1hpp5je7j';
        s1.charset='UTF-8';
        s1.setAttribute('crossorigin','*');
        s0.parentNode.insertBefore(s1,s0);
    })();
    </script>
</body>
</html>
