<?php
include 'S_Client_security.php';
?>

<?php
session_start();
// Získání ID uživatele z relace
$user_id = $_SESSION['user_id'];

$servername = '10.79.157.1:3306';
$username = 'root';
$password = '*****';
$dbname = 'moto_dilna_db';

try {
    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    // Načtení ID přihlášeného uživatele z relace
    $user_id = $_SESSION['user_id'];

    // Načtení údajů přihlášeného uživatele
    $stmt = $conn->prepare("SELECT Osobni_udaje.jmeno,  Osobni_udaje.prijmeni,  Osobni_udaje.datumNarozeni,  Osobni_udaje.email,  Osobni_udaje.telefon
    FROM Klient JOIN Osobni_udaje ON Klient.Osobni_udaje_idOsobni_udaje = Osobni_udaje.idOsobni_udaje WHERE Klient.idKlient = :user_id");
    $stmt->bindParam(':user_id', $user_id);
    $stmt->execute();
    $row = $stmt->fetch(PDO::FETCH_ASSOC);

    $jmeno = $row['jmeno'];
    $prijmeni = $row['prijmeni'];
    $datumNarozeni = $row['datumNarozeni'];
    $email = $row['email'];
    $mobil = $row['telefon'];

    // Načtení motocyklů uživatele
    $stmt = $conn->prepare("SELECT * FROM Motocykl WHERE Klient_idKlient = :user_id");
    $stmt->bindParam(':user_id', $user_id);
    $stmt->execute();
    $motorcycles = $stmt->fetchAll(PDO::FETCH_ASSOC);

    $model = $row['model'];
    $VIN = $row['vin'];
    $rokVyroby = $row['rokVyroby'];

    // Načtení údajů z Adresy uživatele
    $stmt = $conn->prepare("SELECT * FROM Adresa
    JOIN Osobni_udaje ON Adresa.idAdresa = Osobni_udaje.Adresa_idAdresa 
    JOIN Klient ON Osobni_udaje.idOsobni_udaje = Klient.Osobni_udaje_idOsobni_udaje
    WHERE Klient.idKlient = :user_id");
    $stmt->bindParam(':user_id', $user_id);
    $stmt->execute();
    $row = $stmt->fetch(PDO::FETCH_ASSOC);

    $mesto = $row['mesto'];
    $ulice = $row['ulice'];
    $cisloPopisne = $row['cisloPopisne'];
    $psc = $row['psc'];

    // Načtení iča uživatele
    $stmt = $conn->prepare("SELECT ico FROM Klient WHERE idKlient = :user_id");
    $stmt->bindParam(':user_id', $user_id);
    $stmt->execute();
    $row = $stmt->fetch(PDO::FETCH_ASSOC);

    $ico = $row['ico'];

    $userInfo = $stmt->fetch(PDO::FETCH_ASSOC);

} catch(PDOException $e) {
    echo "Připojení k databázi selhalo: " . $e->getMessage();
}
?>

<!DOCTYPE html>
<html lang="cs">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Uživatelský profil</title>
  <link href="scss.css" rel="stylesheet" />
  <link rel="icon" type="image/png" href="Photo.png">
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>
<body>
    <div class="container-fluid">
        <div class="row">
            <div class="col-lg-2 col-md-3 purple-bar">
                <div class="button-container">
                  <br>
                    <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='C_Addmoto.php';">Přidat motocykl</button>
                    <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='C_Chat.php';">Podpora</button>
                </div>
            </div>
            <div class="col-lg-8 col-md-8">
                <div class="middle-bar">
                    <div class="enter">
                        <div class="centered-text">
                            <div class="content">
                             <h1><b>Účet uživatele</b></h1>
                            </div>
                                <div class="custom-frame">  
                                    <div class="row">
                                        <div class="col-md-6">                                                                              
                                            <div class="custom-frame">
                                                <div class="centered-text">
                                                    <h4><b>Uživatelské údaje</b></h4>
                                                </div>
                                                <br>
                                                <form method="post" action="<?php echo htmlspecialchars($_SERVER["PHP_SELF"]); ?>">
                                                    <div class="row">
                                                        <div class="col-xs-12 col-sm-6 mx-auto">
                                                            <div class="form-group">
                                                                <div class="form-control text-center">Jméno:</div>
                                                                <div class="form-control text-center">Příjmení:</div>
                                                                <div class="form-control text-center">Datum narození:</div>
                                                                <div class="form-control text-center">Email:</div>
                                                                <div class="form-control text-center">Mobil:</div>
                                                            </div>
                                                        </div>
                                                        <div class="col-xs-12 col-sm-6 mx-auto">
                                                            <div class="form-group">
                                                                <input type="text" id="jmeno" class="form-control text-center" value="<?php echo $jmeno; ?>" readonly>
                                                                <input type="text" id="prijmeni" class="form-control text-center" value="<?php echo $prijmeni; ?>" readonly>
                                                                <input type="date" id="datum" class="form-control text-center" value="<?php echo $datumNarozeni; ?>" readonly>
                                                                <input type="email" id="email" name="email" class="form-control text-center" value="<?php echo $email; ?>" disabled>
                                                                <input type="text" id="telefon" name="telefon" class="form-control text-center" value="<?php echo $mobil; ?>" disabled>
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div id="editFormContainer"></div>
                                                    <br>
                                                    <div class="centered-text">
                                                        <button type="button" class="btn btn-primary mb-3" onclick="editEvent('<?php echo htmlspecialchars($email); ?>', '<?php echo htmlspecialchars($mobil); ?>')">Upravit</button>
                                                        <script>
                                                                function editEvent(email, telefon) {
                                                                    // Vytvoření formuláře pro úpravu události
                                                                    let form = document.createElement('form');
                                                                    form.method = 'post';
                                                                    form.action = 'S_Update_Osob_Udaj.php';

                                                                    // Vytvoření popisků
                                                                    let emailLabel = document.createElement('label');
                                                                    emailLabel.innerHTML = 'Email:';
                                                                    emailLabel.setAttribute('for', 'emailInput');

                                                                    let telefonLabel = document.createElement('label');
                                                                    telefonLabel.innerHTML = 'Mobil:';
                                                                    telefonLabel.setAttribute('for', 'telefonInput');

                                                                    // Vytvoření inputů
                                                                    let emailInput = document.createElement('input');
                                                                    emailInput.type = 'email';
                                                                    emailInput.id = 'emailInput';
                                                                    emailInput.name = 'email';
                                                                    emailInput.placeholder = 'Zadejte váš email';
                                                                    emailInput.value = email;

                                                                    let telefonInput = document.createElement('input');
                                                                    telefonInput.type = 'text';
                                                                    telefonInput.id = 'telefonInput';
                                                                    telefonInput.name = 'telefon';
                                                                    telefonInput.placeholder = 'Zadejte váš telefon';
                                                                    telefonInput.value = telefon;

                                                                    // Tlačítko pro potvrzení
                                                                    let okButton = document.createElement('button');
                                                                    okButton.type = 'submit';
                                                                    okButton.className = 'btn btn-primary mb-3';
                                                                    okButton.textContent = 'OK';

                                                                    // Přidání do formuláře
                                                                    form.appendChild(emailLabel);
                                                                    form.appendChild(emailInput);
                                                                    form.appendChild(document.createElement('br'));
                                                                    form.appendChild(telefonLabel);
                                                                    form.appendChild(telefonInput);
                                                                    form.appendChild(document.createElement('br'));
                                                                    form.appendChild(okButton);

                                                                    // Nahrazení obsahu kontejneru formuláře
                                                                    let formContainer = document.getElementById('editFormContainer');
                                                                    formContainer.innerHTML = '';
                                                                    formContainer.appendChild(form);

                                                                    // Odeslání formuláře na server
                                                                    form.addEventListener('submit', function(event) {
                                                                        event.preventDefault();
                                                                        let formData = new FormData(form);
                                                                        fetch(form.action, {
                                                                            method: 'POST',
                                                                            body: formData
                                                                        }).then(response => {
                                                                            if (response.ok) {
                                                                                location.reload();
                                                                            } else {
                                                                                alert('Chyba při ukládání údajů');
                                                                            }
                                                                        }).catch(error => alert('Chyba při komunikaci se serverem'));
                                                                    });
                                                                }
                                                        </script>
                                                    </div>
                                                </form>
                                                </div>
                                                <div class="custom-frame">
                                                    <div class="centered-text">
                                                        <h4><b>Adresní údaje</b></h4>
                                                    </div>
                                                <br>
                                                <form method="post" action="<?php echo htmlspecialchars($_SERVER["PHP_SELF"]); ?>">
                                                    <div class="row">
                                                        <div class="col-xs-12 col-sm-6 mx-auto">
                                                            <div class="form-group">
                                                                <div class="form-control text-center">Město:</div>
                                                                <div class="form-control text-center">Ulice:</div>
                                                                <div class="form-control text-center">Číslo popisné:</div>
                                                                <div class="form-control text-center">PSČ:</div>
                                                            </div>
                                                        </div>
                                                        <div class="col-xs-12 col-sm-6 mx-auto">
                                                            <div class="form-group">
                                                                <input type="text" id="mesto" class="form-control text-center" value="<?php echo $mesto; ?>" disabled>
                                                                <input type="text" id="ulice" class="form-control text-center" value="<?php echo $ulice; ?>" disabled>
                                                                <input type="text" id="cisloPopisne" name="cisloPopisne" class="form-control text-center" value="<?php echo $cisloPopisne; ?>" disabled>
                                                                <input type="text" id="psc" name="psc" class="form-control text-center" value="<?php echo $psc; ?>" disabled>
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div id="editAdressContainer"></div>
                                                    <br>
                                                        <div class="centered-text">
                                                        <button type="button" class="btn btn-primary mb-3" onclick="editAdress('<?php echo htmlspecialchars($mesto); ?>', '<?php echo htmlspecialchars($ulice); ?>', '<?php echo htmlspecialchars($cisloPopisne); ?>', '<?php echo htmlspecialchars($psc); ?>')">Upravit</button>
                                                        <script>
                                                        function editAdress(mesto, ulice, cisloPopisne, psc) {
                                                            // Vytvoření formuláře pro úpravu události
                                                            let form = document.createElement('form');
                                                            form.method = 'post';
                                                            form.action = 'S_Update_adress_udaj.php';

                                                            // Vytvoření popisků
                                                            let mestoLabel = document.createElement('label');
                                                            mestoLabel.innerHTML = 'Město:';
                                                            mestoLabel.setAttribute('for', 'mestoInput');

                                                            let uliceLabel = document.createElement('label');
                                                            uliceLabel.innerHTML = 'Ulice:';
                                                            uliceLabel.setAttribute('for', 'uliceInput');

                                                            let cisloPopisneLabel = document.createElement('label');
                                                            cisloPopisneLabel.innerHTML = 'Číslo popisné:';
                                                            cisloPopisneLabel.setAttribute('for', 'cisloPopisneInput');

                                                            let pscLabel = document.createElement('label');
                                                            pscLabel.innerHTML = 'PSČ:';
                                                            pscLabel.setAttribute('for', 'pscInput');

                                                            // Vytvoření inputů
                                                            let mestoInput = document.createElement('input');
                                                            mestoInput.type = 'text';
                                                            mestoInput.id = 'mestoInput';
                                                            mestoInput.name = 'mesto';
                                                            mestoInput.placeholder = 'Zadejte město';
                                                            mestoInput.value = mesto;

                                                            let uliceInput = document.createElement('input');
                                                            uliceInput.type = 'text';
                                                            uliceInput.id = 'uliceInput';
                                                            uliceInput.name = 'ulice';
                                                            uliceInput.placeholder = 'Zadejte ulici';
                                                            uliceInput.value = ulice;

                                                            let cisloPopisneInput = document.createElement('input');
                                                            cisloPopisneInput.type = 'text';
                                                            cisloPopisneInput.id = 'cisloPopisneInput';
                                                            cisloPopisneInput.name = 'cisloPopisne';
                                                            cisloPopisneInput.placeholder = 'Zadejte číslo popisné';
                                                            cisloPopisneInput.value = cisloPopisne;

                                                            let pscInput = document.createElement('input');
                                                            pscInput.type = 'text';
                                                            pscInput.id = 'pscInput';
                                                            pscInput.name = 'psc';
                                                            pscInput.placeholder = 'Zadejte PSČ';
                                                            pscInput.value = psc;

                                                            let okButton = document.createElement('button');
                                                            okButton.type = 'submit';
                                                            okButton.className = 'btn btn-primary mb-3';
                                                            okButton.textContent = 'OK';

                                                            // Přidání do formuláře
                                                            form.appendChild(mestoLabel);
                                                            form.appendChild(mestoInput);
                                                            form.appendChild(document.createElement('br'));
                                                            form.appendChild(uliceLabel);
                                                            form.appendChild(uliceInput);
                                                            form.appendChild(document.createElement('br'));
                                                            form.appendChild(cisloPopisneLabel);
                                                            form.appendChild(cisloPopisneInput);
                                                            form.appendChild(document.createElement('br'));
                                                            form.appendChild(pscLabel);
                                                            form.appendChild(pscInput);
                                                            form.appendChild(document.createElement('br'));
                                                            form.appendChild(okButton);

                                                            // Nahrazení obsahu kontejneru formuláře
                                                            let formContainer = document.getElementById('editAdressContainer');
                                                            formContainer.innerHTML = '';
                                                            formContainer.appendChild(form);

                                                            // Odeslání formuláře na server
                                                            form.addEventListener('submit', function(event) {
                                                                event.preventDefault();
                                                                let formData = new FormData(form);
                                                                fetch(form.action, {
                                                                    method: 'POST',
                                                                    body: formData
                                                                }).then(response => {
                                                                    if (response.ok) {
                                                                        location.reload();
                                                                    } else {
                                                                        alert('Chyba při ukládání údajů');
                                                                    }
                                                                }).catch(error => alert('Chyba při komunikaci se serverem'));
                                                            });
                                                        }
                                                        </script>
                                                    </div>
                                                </form>
                                                </div>
                                                <div class="custom-frame">
                                                    <div class="centered-text">
                                                        <h4><b>Vaše IČO</b></h4>
                                                    </div>
                                                    <br>
                                                    <form method="post" action="<?php echo htmlspecialchars($_SERVER["PHP_SELF"]); ?>">
                                                        <div class="row">
                                                            <div class="col-xs-12 col-sm-6 mx-auto">
                                                                <div class="form-group">
                                                                    <div class="form-control text-center">IČO:</div>
                                                                </div>
                                                            </div>
                                                            <div class="col-xs-12 col-sm-6 mx-auto">
                                                                <div class="form-group">
                                                                    <input type="text" id="ico" name="ico" class="form-control text-center" value="<?php echo $ico; ?>" disabled>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div id="editIcoContainer"></div>
                                                        <br>
                                                        <div class="centered-text">
                                                            <button type="button" class="btn btn-primary mb-3" onclick="editIco('<?php echo htmlspecialchars($ico); ?>')">Upravit</button>
                                                            <script>
                                                                function editIco(ico) {
                                                                    // Vytvoření formuláře pro úpravu události
                                                                    let form = document.createElement('form');
                                                                    form.method = 'post';
                                                                    form.action = 'S_Update_ico.php';

                                                                    // Vytvoření popisků
                                                                    let icoLabel = document.createElement('label');
                                                                    icoLabel.innerHTML = 'IČO:';
                                                                    icoLabel.setAttribute('for', 'icoInput');

                                                                    // Vytvoření inputů
                                                                    let icoInput = document.createElement('input');
                                                                    icoInput.type = 'text';
                                                                    icoInput.id = 'icoInput';
                                                                    icoInput.name = 'ico';
                                                                    icoInput.placeholder = 'Zadejte IČO';
                                                                    icoInput.value = ico;

                                                                    let okButton = document.createElement('button');
                                                                    okButton.type = 'submit';
                                                                    okButton.className = 'btn btn-primary mb-3';
                                                                    okButton.textContent = 'OK';

                                                                    // Přidání do formuláře
                                                                    form.appendChild(icoLabel);
                                                                    form.appendChild(icoInput);
                                                                    form.appendChild(document.createElement('br'));
                                                                    form.appendChild(okButton);

                                                                    // Nahrazení obsahu kontejneru formuláře
                                                                    let formContainer = document.getElementById('editIcoContainer');
                                                                    formContainer.innerHTML = '';
                                                                    formContainer.appendChild(form);

                                                                    // Odeslání formuláře na server
                                                                    form.addEventListener('submit', function(event) {
                                                                        event.preventDefault();
                                                                        let formData = new FormData(form);
                                                                        fetch(form.action, {
                                                                            method: 'POST',
                                                                            body: formData
                                                                        }).then(response => {
                                                                            if (response.ok) {
                                                                                location.reload();
                                                                            } else {
                                                                                alert('Chyba při ukládání údajů');
                                                                            }
                                                                        }).catch(error => alert('Chyba při komunikaci se serverem'));
                                                                    });
                                                                }
                                                            </script>
                                                        </div>
                                                    </form>
                                                </div>
                                            </div>                                                          
                                            <div class="col-md-6">
                                                <div class="custom-frame">                                                                                                                    
                                                    <div class="centered-text">
                                                    <h4><b>Vaše strojovna</b></h4> 
                                                    <?php foreach($motorcycles as $motorcycle): ?>
                                                        <?php
                                                        // Načtení názvu značky podle ID
                                                        $stmt = $conn->prepare("SELECT nazev FROM Znacka WHERE idZnacka = :znacka_id");
                                                        $stmt->bindParam(':znacka_id', $motorcycle['Znacka_idZnacka']);
                                                        $stmt->execute();
                                                        $row = $stmt->fetch(PDO::FETCH_ASSOC);
                                                        $nazevZnacky = $row['nazev'];
                                                        ?>

                                                        <div class="custom-frame">
                                                            <h6><b><?php echo $nazevZnacky; ?></b></h6>
                                                            <b>Model:</b> <?php echo $motorcycle['model']; ?><br>
                                                            <b>VIN:</b> <?php echo $motorcycle['vin']; ?><br>
                                                            <b>Rok výroby:</b> <?php echo $motorcycle['rokVyroby']; ?><br>
                                                            <br><img src="<?php echo $motorcycle['foto']; ?>" alt="Obrázek" class="img-fluid" width="230" height="160">
                                                            <div class="center">
                                                            <br>
                                                            <a href="C_Motoupgrade.php?id=<?php echo $motorcycle['idMotocykl']; ?>" class="btn btn-primary mb-3">Podrobnosti</a>
                                                            <a href="C_Moto_photo.php?id=<?php echo $motorcycle['idMotocykl']; ?>" class="btn btn-primary mb-3">Servisní historie</a>
                                                            </div>
                                                        </div>
                                                    <?php endforeach; ?>
                                                    </div>                                                                            
                                                </div>  
                                            </div>                                                               
                                        </div>
                                    </div>
                                </div>            
                            </div>
                        </div>
                    </div>
                    <div class="col-lg-2 col-md-3 purple-bar">
                        <div class="button-container">
                        <br>
                        <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='C_Client.php';">Domov</button>
                        <button type="button" class="btn btn-primary mb-3" onclick="openChangePasswordModal()"><b>Nastavení</b></button>
                        <!-- Vyskakovací okno pro změnu hesla -->
                        <div id="changePasswordModal" class="modal">
                            <div class="modal-content">
                                <span class="close" onclick="closeChangePasswordModal()">&times;</span>
                                <h2>Změna hesla</h2>
                                <div class="form-group">
                                    <form method="post" action="S_ClientPASS.php">
                                        <label for="newPassword">Nové heslo:</label>
                                        <input type="password" class="form-control" name="newPassword" id="newPassword" placeholder="Zadejte nové heslo">
                                        <br>
                                        <button type="submit" class="btn btn-primary">Uložit</button>
                                    </form>
                                </div>
                            </div>
                        </div>
                        <script>
                            // Otevření vyskakovacího okna
                            function openChangePasswordModal() {
                                document.getElementById("changePasswordModal").style.display = "block";
                            }
                            // FZavření vyskakovacího okna
                            function closeChangePasswordModal() {
                                document.getElementById("changePasswordModal").style.display = "none";
                            }
                        </script>
                        <form method="post">
                         <button type="submit" name="logout" class="btn btn-danger mb-3">Odhlásit se</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
<script type="text/javascript">
var Tawk_API=Tawk_API||{}, Tawk_LoadStart=new Date();

// Předdefinování atributů a funkcí
window.Tawk_API = window.Tawk_API || {};
window.Tawk_API.onLoad = function() {
    Tawk_API.setAttributes({
        'name' : '<?php echo $jmeno . " " . $prijmeni; ?>',
        'email' : '<?php echo $email; ?>',
    }, function(error){});

    // Přidání události nebo poznámky
    Tawk_API.addEvent('Informace o klientovi', {
        'Jméno': '<?php echo $jmeno; ?>',
        'Příjmení': '<?php echo $prijmeni; ?>',
        'E-mail': '<?php echo $email; ?>',
    }, function(error, success){});
};

// Načtení skriptu Tawk.to
(function(){
    var s1=document.createElement("script"),s0=document.getElementsByTagName("script")[0];
    s1.async=true;
    s1.src='https://embed.tawk.to/66009a091ec1082f04dab4dd/1hpp5je7j';
    s1.charset='UTF-8';
    s1.setAttribute('crossorigin','*');
    s0.parentNode.insertBefore(s1,s0);
})();
</script>
</body>
</html>