<?php
include 'S_Client_security.php';
?>

<?php
session_start();
// Získání ID uživatele z relace
$user_id = $_SESSION['user_id'];
// Získání ID motocyklu z relace
$idMotocyklu = $_GET['id'];

$servername = '10.79.157.1:3306';
$username = 'root';
$password = '*****';
$dbname = 'moto_dilna_db';

try {
    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    // Údaje přihlášeného uživatele
    $stmt = $conn->prepare("SELECT Osobni_udaje.jmeno,  Osobni_udaje.prijmeni,  Osobni_udaje.datumNarozeni,  Osobni_udaje.email,  Osobni_udaje.telefon
    FROM Klient
    JOIN Osobni_udaje ON Klient.Osobni_udaje_idOsobni_udaje = Osobni_udaje.idOsobni_udaje
    WHERE Klient.idKlient = :user_id");
    $stmt->bindParam(':user_id', $user_id);
    $stmt->execute();
    $row = $stmt->fetch(PDO::FETCH_ASSOC);

    $jmeno = $row['jmeno'];
    $prijmeni = $row['prijmeni'];
    $datumNarozeni = $row['datumNarozeni'];
    $email = $row['email'];
    $mobil = $row['telefon'];

    //Načtení informací o motocyklu
    $stmt = $conn->prepare("SELECT * FROM Motocykl WHERE idMotocykl = :idMotocyklu");
    $stmt->bindParam(':idMotocyklu', $idMotocyklu);
    $stmt->execute();
    $motorcycle = $stmt->fetch(PDO::FETCH_ASSOC);

    // Načtení událostí pro motocykl
    $stmt = $conn->prepare("SELECT * FROM Udalost WHERE Motocykl_idMotocykl = :idMotocyklu");
    $stmt->bindParam(':idMotocyklu', $idMotocyklu);
    $stmt->execute();
    $events = $stmt->fetchAll(PDO::FETCH_ASSOC);

} catch(PDOException $e) {
    echo "Připojení k databázi selhalo: " . $e->getMessage();
}
?>


<!DOCTYPE html>
<html lang="cs">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Podrobný záznam servisu</title>
    <link rel="icon" type="image/png" href="Photo.png">
    <link href="scss.css" rel="stylesheet" />
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>
<body>
    <div class="container-fluid">
        <div class="row">
            <div class="col-lg-2 col-md-3 purple-bar">
                <br>
                <div class="card">
                    <div class="card-body">
                        <div class="custom-frame">
                            <?php
                            // Načtení názvu značky podle ID
                            $stmt = $conn->prepare("SELECT nazev FROM Znacka WHERE idZnacka = :znacka_id");
                            $stmt->bindParam(':znacka_id', $motorcycle['Znacka_idZnacka']);
                            $stmt->execute();
                            $row = $stmt->fetch(PDO::FETCH_ASSOC);
                            $nazevZnacky = $row['nazev'];
                            ?>
                            <img src="<?php echo $motorcycle['foto']; ?>" alt="Obrázek" class="img-fluid" width="230" height="160">
                            <b>Značka: </b><?php echo $nazevZnacky; ?></br>
                            <b>Model:</b> <?php echo $motorcycle['model']; ?><br>
                            <b>VIN:</b> <?php echo $motorcycle['vin']; ?><br>
                            <b>Rok výroby:</b> <?php echo $motorcycle['rokVyroby']; ?><br>
                            <b>Stav KM:</b> <span id="stavKM"><?php echo $motorcycle['pocetKM']; ?></span>
                            <input type="text" id="editStavKM" style="display: none;" value="<?php echo $motorcycle['pocetKM']; ?>"><br>
                            <b>Platnost STK:</b> <span id="platnostSTK"><?php echo $motorcycle['platnostSTK']; ?></span>
                            <input type="text" id="editPlatnostSTK" style="display: none;" value="<?php echo $motorcycle['platnostSTK']; ?>"><br>
                        </div>
                    </div>
                </div>
                <br>
                <div class="card">
                    <div class="card-body">
                        <b>Jméno a příjmení</b><br>
                        <input type="text" id="jmeno" value="<?php echo $jmeno . ' ' . $prijmeni; ?>" readonly><br>
                        <b>Datum narození</b><br>
                        <input type="date" id="datum" value="<?php echo $datumNarozeni; ?>" readonly><br>
                        <b>Email</b><br>
                        <input type="email" id="email" value="<?php echo $email; ?>" readonly><br>
                        <b>Mobil</b><br>
                        <input type="telefon" id="telefon" value="<?php echo $mobil; ?>" readonly><br>
                    </div>
                </div>
                <br>
                <div class="button-container">
                    <button type="button" class="btn btn-primary mb-3" onclick="window.history.back();">Zpět</button>
                </div>
            </div>
            <div class="col-lg-8 col-md-8"> 
                <div class="middle-bar">
                    <div class="content">
                        <div class="centered-text">
                        <h1><b>Podrobný záznam servisu</b></h1>                            
                            <div class="container">
                                <div class="info-scrollable">
                                    <div class="container">
                                        <?php
                                        $servername = '10.79.157.1:3306';
                                        $username = 'root';
                                        $password = '*****';
                                        $dbname = 'moto_dilna_db';

                                        try {
                                            // Dotaz na fotografie a události
                                            $sql_photos_events = "SELECT Udalost.idUdalost, Udalost.nazevudalosti, Udalost.datumZahajeni, Udalost.datumUkonceni, Udalost.poznamky,  Udalost.podrobnosti, GROUP_CONCAT(Udalost.fotky) AS fotky
                                                                FROM Udalost
                                                                WHERE Udalost.Motocykl_idMotocykl = (SELECT idMotocykl FROM Motocykl WHERE idMotocykl = :idMotocyklu)
                                                                GROUP BY Udalost.idUdalost";
                                            $stmt_photos_events = $conn->prepare($sql_photos_events);
                                            $stmt_photos_events->bindParam(':idMotocyklu', $idMotocyklu);
                                            $stmt_photos_events->execute();
                                            $result_photos_events = $stmt_photos_events->fetchAll(PDO::FETCH_ASSOC);

                                            foreach ($result_photos_events as $row_photos_events) {
                                                echo '<div class="row">
                                                        <div class="col-xs-12 col-sm-6 col-md-4 text-center border d-flex flex-column justify-content-center align-items-center">';
                                                
                                                // Dotaz na získání loginu uživatele
                                                $sql_login = "SELECT Prihlasovaci_udaje.login
                                                            FROM Osobni_udaje
                                                            JOIN Klient ON Osobni_udaje.idOsobni_udaje = Klient.Osobni_udaje_idOsobni_udaje
                                                            JOIN Prihlasovaci_udaje ON Klient.Prihlasovaci_udaje_idPrihlasovaci_udaje = Prihlasovaci_udaje.idPrihlasovaci_udaje
                                                            WHERE Klient.idKlient = :user_id";
                                                $stmt_login = $conn->prepare($sql_login);
                                                $stmt_login->bindParam(':user_id', $user_id);
                                                $stmt_login->execute();
                                                $row_login = $stmt_login->fetch(PDO::FETCH_ASSOC);
                                                
                                                // Načtení loginu uživatele
                                                $login = $row_login['login'];

                                                // Adresa složky s fotkami
                                                $idUdalost = $row_photos_events['idUdalost'];
                                                $photosFolder = "images/{$login}/{$idUdalost}/";

                                                if (is_dir($photosFolder)) {
                                                    // Získání seznamu souborů ve složce
                                                    $files = scandir($photosFolder);
                                                    echo '<div class="row mb-3">';
                                                    foreach ($files as $file) {
                                                        // Vynechání odkazů na současné adresáře a nadřazené adresáře
                                                        if ($file === '.' || $file === '..') continue;

                                                        // Vytvoření úplné cesty k souboru
                                                        $photoPath = $photosFolder . $file;

                                                        // Vytvoření odkazu na fotografii
                                                        echo '<div class="col" style="margin-bottom: 1px;">
                                                            <a href="' . $photoPath . '" data-lightbox="photos">
                                                <img src="' . $photoPath . '" alt="Photo" class="img-fluid" width="60" height="100"></a>
                                                </div>';
                                                    }
                                                    echo '</div>';  
                                                } else {
                                                    echo "Fotodokumentace nebyla doposud vložena!";
                                                    echo '<div class="card">    
                                                </div>';
                                                }

                                                // Vypsání událostí
                                                echo '</div>
                                                    <div class="col-xs-12 col-sm-6 col-md-8 text-center border d-flex flex-column justify-content-center align-items-center">
                                                    <b><i>Název události: </i>' . $row_photos_events['nazevudalosti'] . '</b>
                                                    <b><i>Datum zahájení: </i>' . $row_photos_events['datumZahajeni'] . '</b>
                                                    <b><i>Datum ukončení: </i>' . $row_photos_events['datumUkonceni'] . '</b>
                                                    <b><i>Poznámky: </i>' . $row_photos_events['poznamky'] . '</b><br>
                                                        <b>' . $row_photos_events['podrobnosti'] . '</b><br>
                                                        </div>
                                                    </div>';
                                            }
                                        } catch(PDOException $e) {
                                            echo "Chyba při načítání dat: " . $e->getMessage();
                                        }
                                        ?>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>              
                </div>
            </div>
            <!-- Připojení lightbox knihovny -->
            <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/lightbox2/2.11.3/css/lightbox.min.css">
            <script src="https://cdnjs.cloudflare.com/ajax/libs/lightbox2/2.11.3/js/lightbox.min.js"></script>
            <div class="col-lg-2 col-md-3 purple-bar">
                <div class="button-container">
                    <br>
                    <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='C_Client.php';">Domov</button>
                    <form method="post">
                        <button type="submit" name="logout" class="btn btn-danger mb-3">Odhlásit se</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <script type="text/javascript">
    var Tawk_API=Tawk_API||{}, Tawk_LoadStart=new Date();

    // Předdefinování atributů a funkcí
    window.Tawk_API = window.Tawk_API || {};
    window.Tawk_API.onLoad = function() {
        Tawk_API.setAttributes({
            'name' : '<?php echo $jmeno . " " . $prijmeni; ?>',
            'email' : '<?php echo $email; ?>',
        }, function(error){});

        // Přidání události nebo poznámky
        Tawk_API.addEvent('Informace o klientovi', {
            'Jméno': '<?php echo $jmeno; ?>',
            'Příjmení': '<?php echo $prijmeni; ?>',
            'E-mail': '<?php echo $email; ?>',
        }, function(error, success){});
    };

    // Načtení skriptu Tawk.to
    (function(){
        var s1=document.createElement("script"),s0=document.getElementsByTagName("script")[0];
        s1.async=true;
        s1.src='https://embed.tawk.to/66009a091ec1082f04dab4dd/1hpp5je7j';
        s1.charset='UTF-8';
        s1.setAttribute('crossorigin','*');
        s0.parentNode.insertBefore(s1,s0);
    })();
    </script>
</body>
</html>