<?php
include 'S_Client_security.php';
?>

<?php
session_start();
// Získání ID uživatele z relace
$user_id = $_SESSION['user_id'];
// Získání ID motocyklu z relace
$idMotocyklu = $_GET['id'];

$servername = '10.79.157.1:3306';
$username = 'root';
$password = '*****';
$dbname = 'moto_dilna_db';

try {
    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    // Údaje přihlášeného uživatele
    $stmt = $conn->prepare("SELECT Osobni_udaje.jmeno,  Osobni_udaje.prijmeni,  Osobni_udaje.datumNarozeni,  Osobni_udaje.email,  Osobni_udaje.telefon
    FROM Klient
    JOIN Osobni_udaje ON Klient.Osobni_udaje_idOsobni_udaje = Osobni_udaje.idOsobni_udaje
    WHERE Klient.idKlient = :user_id");
    $stmt->bindParam(':user_id', $user_id);
    $stmt->execute();
    $row = $stmt->fetch(PDO::FETCH_ASSOC);

    $jmeno = $row['jmeno'];
    $prijmeni = $row['prijmeni'];
    $datumNarozeni = $row['datumNarozeni'];
    $email = $row['email'];
    $mobil = $row['telefon'];

    // Načtení informací o motocyklu
    $stmt = $conn->prepare("SELECT * FROM Motocykl WHERE idMotocykl = :idMotocyklu");
    $stmt->bindParam(':idMotocyklu', $idMotocyklu);
    $stmt->execute();
    $motorcycle = $stmt->fetch(PDO::FETCH_ASSOC);

    $model = $row['model'];
    $VIN = $row['vin'];

    if ($_SERVER["REQUEST_METHOD"] == "POST") {
      $stavKM = $_POST['stavKM'];
      $platnostSTK = $_POST['platnostSTK'];

      // Dotaz pro aktualizaci informací o motocyklu
      $stmt = $conn->prepare("UPDATE Motocykl SET pocetKM = :stavKM, platnostSTK = :platnostSTK WHERE idMotocykl = :idMotocyklu");
      $stmt->bindParam(':stavKM', $stavKM);
      $stmt->bindParam(':platnostSTK', $platnostSTK);
      $stmt->bindParam(':idMotocyklu', $idMotocyklu);
      $stmt->execute();
      
      echo "<meta http-equiv='refresh' content='0;url=C_Motoupgrade.php?id={$idMotocyklu}'>";
      exit();
  }
    // Načtení událostí pro motocykl
    $stmt = $conn->prepare("SELECT * FROM Udalost WHERE Motocykl_idMotocykl = :idMotocyklu");
    $stmt->bindParam(':idMotocyklu', $idMotocyklu);
    $stmt->execute();
    $events = $stmt->fetchAll(PDO::FETCH_ASSOC);

  } catch(PDOException $e) {
    echo "Připojení k databázi selhalo: " . $e->getMessage();
}
?>

<!DOCTYPE html>
<html lang="cs">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Úprava motocyklu</title>
  <link rel="icon" type="image/png" href="Photo.png">
  <link href="scss.css" rel="stylesheet" />
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>
<body>
  <div class="container-fluid">
    <div class="row">
      <div class="col-lg-2 col-md-3 purple-bar">
        <br>
        <div class="card">
          <div class="card-body">
            <?php
              // Načtení značky podle ID
              $stmt = $conn->prepare("SELECT nazev FROM Znacka WHERE idZnacka = :idMotocyklu");
              $stmt->bindParam(':idMotocyklu', $motorcycle['Znacka_idZnacka']);
              $stmt->execute();
              $row = $stmt->fetch(PDO::FETCH_ASSOC);
              $nazevZnacky = $row['nazev'];
              ?>
             <h6><b><?php echo $nazevZnacky; ?></b></h6>
             <img src="<?php echo $motorcycle['foto']; ?>" alt="Obrázek" class="img-fluid" width="230" height="160">
          </div>
        </div>
        <br>
        <div class="card">
          <div class="card-body">
            <b>Jméno a příjmení</b><br>
            <input type="text" id="jmeno" value="<?php echo $jmeno . ' ' . $prijmeni; ?>" readonly><br>
            <b>Datum narození</b><br>
            <input type="date" id="datum" value="<?php echo $datumNarozeni; ?>" readonly><br>
            <b>Email</b><br>
            <input type="email" id="email" value="<?php echo $email; ?>" readonly><br>
            <b>Mobil</b><br>
            <input type="telefon" id="telefon" value="<?php echo $mobil; ?>" readonly><br>
          </div>
        </div>
        <br>
        <div class="button-container">
          <button type="button" class="btn btn-primary mb-3" onclick="window.history.back();">Zpět</button>
        </div>
      </div>
      <div class="col-lg-8 col-md-8">
        <div class="middle-bar">
          <div class="enter">
            <div class="centered-text">
              <div class="content">
                <div class="card">
                  <div class="card-body">
                    <b><p style="font-size: 25px;">Specifikace motocyklu</p></b>
                    <b>Značka:</b> <?php echo $nazevZnacky; ?><br>
                    <b>Model:</b> <?php echo $motorcycle['model']; ?><br>
                    <b>VIN:</b> <?php echo $motorcycle['vin']; ?><br>
                    <b>Rok výroby:</b> <?php echo $motorcycle['rokVyroby']; ?><br>
                    <b>Počet KM: </b><span id="stavKM"><?php echo $motorcycle['pocetKM']; ?></span>
                    <input type="text" id="editStavKM" style="display: none;" value="<?php echo $motorcycle['pocetKM']; ?>"><br>
                    <b>Platnost STK:</b>
                    <span id="platnostSTK"><?php echo $motorcycle['platnostSTK']; ?></span>
                    <input type="text" id="editPlatnostSTK" style="display: none;" value="<?php echo $motorcycle['platnostSTK']; ?>"><br>
                    <br>
                    <button type="button" class="btn btn-primary mb-3" onclick="editInfo()">Upravit informace</button>
                    <form method="post" style="display: none;" id="updateForm">
                      <input type="text" name="stavKM" id="updatedStavKM">
                      <input type="text" name="platnostSTK" id="updatedPlatnostSTK" maxlength="10" oninput="formatDateInput(event)">
                      <button type="submit" class="btn btn-success mb-3">OK</button>
                    </form>
                  </div>
                </div>
                <br>      
                <div class="center">
                  <div class="col-md-12">
                    <div class="card">
                        <div class="card-body">
                            <h5 class="card-title">Kalendář akcí</h5>
                            <div class="eneter">
                                <div class="card">
                                  <div class="card-body">
                                      <?php foreach ($events as $event): ?>
                                          <h5 class="card-title"><b>Servis:</b> <u><?php echo $event['nazevUdalosti']; ?></u></h5>
                                          <p><b>Datum zahájení:</b> <?php echo $event['datumZahajeni']; ?></p>
                                          <p><b>Datum ukončení:</b> <?php echo $event['datumUkonceni']; ?></p>
                                          <p><b>Poznámky:</b> <?php echo $event['poznamky']; ?></p>
                                          <p><b>Datum vytvoření:</b> <?php echo $event['datumVytvoreni']; ?></p>
                                          <hr>
                                      <?php endforeach; ?>
                                      <?php if (empty($events)): ?>
                                          <p>Pro tento motocykl nejsou žádné události.</p>
                                      <?php endif; ?>
                                  </div>
                                </div>
                              </div>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
            <div class="col-lg-2 col-md-3 purple-bar">
              <div class="button-container">
                <br>
                <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='C_Client.php';">Domov</button>
                <form method="post">
                  <button type="submit" name="logout" class="btn btn-danger mb-3">Odhlásit se</button>
                </form>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>  
        <script>
          function editInfo() {
            document.getElementById('stavKM').style.display = 'none';
            document.getElementById('platnostSTK').style.display = 'none';
            document.getElementById('updateForm').style.display = 'block';
            document.getElementById('updatedStavKM').value = document.getElementById('editStavKM').value;
            document.getElementById('updatedPlatnostSTK').value = document.getElementById('editPlatnostSTK').value;
          }
          function formatDateInput(event) {
            let input = event.target;
            let value = input.value.replace(/\D/g, '');

            if (value.length > 8) {
              value = value.slice(0, 8);
            }

            let formattedValue = '';
            for (let i = 0; i < value.length; i++) {
              if (i === 4 || i === 6) {
                formattedValue += '-';
              }
              formattedValue += value[i];
            }

            input.value = formattedValue;
          }
          document.getElementById('editPlatnostSTK').addEventListener('input', formatDateInput);
        </script>
  <script type="text/javascript">
  var Tawk_API=Tawk_API||{}, Tawk_LoadStart=new Date();

  // Předdefinování atributů a funkcí
  window.Tawk_API = window.Tawk_API || {};
  window.Tawk_API.onLoad = function() {
      Tawk_API.setAttributes({
          'name' : '<?php echo $jmeno . " " . $prijmeni; ?>',
          'email' : '<?php echo $email; ?>',
      }, function(error){});

      Tawk_API.addEvent('Informace o klientovi', {
          'Jméno': '<?php echo $jmeno; ?>',
          'Příjmení': '<?php echo $prijmeni; ?>',
          'E-mail': '<?php echo $email; ?>',
      }, function(error, success){});
  };

  // Načtení skriptu Tawk.to
  (function(){
      var s1=document.createElement("script"),s0=document.getElementsByTagName("script")[0];
      s1.async=true;
      s1.src='https://embed.tawk.to/66009a091ec1082f04dab4dd/1hpp5je7j';
      s1.charset='UTF-8';
      s1.setAttribute('crossorigin','*');
      s0.parentNode.insertBefore(s1,s0);
  })();
  </script>
</body>
</html>