<?php
include 'S_security.php';

require '/home/vendor/autoload.php';

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

// Odeslání e-mailu
function sendEmail($to, $subject, $message) {
    $mail = new PHPMailer(true);

    try {
      $mail->isSMTP();
      $mail->Host = 'smtp.seznam.cz';
      $mail->SMTPAuth = true;
      $mail->Username = 'infomoto@rigldavid.fun';
      $mail->Password = '*****';
      $mail->SMTPSecure = 'ssl';
      $mail->Port = 465;

        $mail->CharSet = 'UTF-8';

        // Nastavení odesílatele a příjemce
        $mail->setFrom('infomoto@rigldavid.fun', 'Moto dilna DP');
        $mail->addAddress($to);

        $mail->isHTML(true);
        $mail->Subject = $subject;
        $mail->Body = $message;

        // Odeslání emailu
        $mail->send();
        return true;
    } catch (Exception $e) {
        error_log($mail->ErrorInfo);
        echo "Chyba při odesílání emailu: " . $mail->ErrorInfo;
        return false;
    }
}
?>

<!DOCTYPE html>
<html lang="cs">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Přidání klienta</title>
  <link rel="icon" type="image/png" href="Photo.png">
  <link href="scss.css" rel="stylesheet" />
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>
<body>
    <div class="container-fluid">
        <div class="row">
            <div class="col-lg-2 col-md-3 purple-bar">
                <div class="button-container">
                 <br>
                 <button type="button" class="btn btn-primary mb-3" onclick="window.history.back();">Zpět</button>
                </div>
            </div>
            <div class="col-lg-8 col-md-4">
                <div class="middle-bar">
                    <div class="enter">
                        <div class="centered-text">
                            <div class="content">
                             <h1><b>Přidání uživatele</b></h1>
                            </div>
                        </div>     
                        <?php

                        $servername = '10.79.157.1:3306';
                        $username = 'root';
                        $password = '*****';
                        $dbname = 'moto_dilna_db';

                        try {
                            $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
                            $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
                        } catch(PDOException $e) {
                            echo "Chyba při připojování k databázi: " . $e->getMessage();
                        }

                        // Kontrolu existence uživatele
                        function userExists($conn, $jmeno, $prijmeni, $datumNarozeni, $telefon, $email) {
                            $sql = "SELECT * FROM Osobni_udaje WHERE jmeno = :jmeno AND prijmeni = :prijmeni AND datumNarozeni = :datumNarozeni AND telefon = :telefon AND email = :email";
                            $stmt = $conn->prepare($sql);
                            $stmt->bindParam(':jmeno', $jmeno);
                            $stmt->bindParam(':prijmeni', $prijmeni);
                            $stmt->bindParam(':datumNarozeni', $datumNarozeni);
                            $stmt->bindParam(':telefon', $telefon);
                            $stmt->bindParam(':email', $email);
                            $stmt->execute();
                            return $stmt->rowCount() > 0;
                        }
                        function generateRandomLogin($jmeno, $prijmeni, $conn) {
                            // Převod příjmení na malá písmena
                            $prijmeniLowerCase = mb_strtolower($prijmeni, 'UTF-8');
                            // Odstranění diakritiky z příjmení
                            $prijmeniWithoutDiacritics = removeAccents($prijmeniLowerCase);
                            // Přidání prvního písmena ze jména
                            $login = $prijmeniWithoutDiacritics . substr(strtolower($jmeno), 0, 1);
                            
                            // Pokud login existuje, přidá se číslo
                            $suffix = '';
                            while (loginExists($conn, $login . $suffix)) {
                                if ($suffix === '') {
                                    $suffix = 1;
                                } else {
                                    $suffix++;
                                }
                                $login = $prijmeniWithoutDiacritics . substr(strtolower($jmeno), 0, 1) . $suffix;
                            }
                            
                            return $login;
                        }

                        function removeAccents($string) {
                            $accents = array('á', 'č', 'ď', 'é', 'ě', 'í', 'ň', 'ó', 'ř', 'š', 'ť', 'ú', 'ů', 'ý', 'ž', 'Á', 'Č', 'Ď', 'É', 'Ě', 'Í', 'Ň', 'Ó', 'Ř', 'Š', 'Ť', 'Ú', 'Ů', 'Ý', 'Ž');
                            $without = array('a', 'c', 'd', 'e', 'e', 'i', 'n', 'o', 'r', 's', 't', 'u', 'u', 'y', 'z', 'A', 'C', 'D', 'E', 'E', 'I', 'N', 'O', 'R', 'S', 'T', 'U', 'U', 'Y', 'Z');
                            return str_replace($accents, $without, $string);
                        }

                        // Generování náhodného hesla
                        function generateRandomPassword($length = 8) {
                            $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ!%&*()-_+=';
                            $genhesl = '';
                            // Nastavení na jednoho velké písmeno, jednoho malé písmeno, jedno číslo a jeden speciální znak
                            $genhesl .= substr(str_shuffle('abcdefghijklmnopqrstuvwxyz'), 0, 1); // Malé písmeno
                            $genhesl .= substr(str_shuffle('ABCDEFGHIJKLMNOPQRSTUVWXYZ'), 0, 1); // Velké písmeno
                            $genhesl .= substr(str_shuffle('0123456789'), 0, 1); // Číslo
                            $genhesl .= substr(str_shuffle('!%&*()-_+='), 0, 1); // Speciální znak
                            // Náhodné doplnění zbylých znaků
                            for ($i = 4; $i < $length; $i++) {
                                $genhesl .= $characters[rand(0, strlen($characters) - 1)];
                            }
                            return $genhesl;
                        }

                        // Kontrola existence loginu
                        function loginExists($conn, $login) {
                            $sql = "SELECT * FROM Prihlasovaci_udaje WHERE login = :login";
                            $stmt = $conn->prepare($sql);
                            $stmt->bindParam(':login', $login);
                            $stmt->execute();
                            return $stmt->rowCount() > 0;
                        }

                        // Vložení uživatele do databáze
                        function insertUser($conn, $jmeno, $prijmeni, $datumNarozeni, $telefon, $email, $psc, $ulice, $cisloPopisne, $mesto, $login, $heslo_hash, $prava) {
                            try {
                                $conn->beginTransaction();

                                // Vložení adresy
                                $sql = "INSERT INTO Adresa (psc, ulice, cisloPopisne, mesto) VALUES (:psc, :ulice, :cisloPopisne, :mesto)";
                                $stmt = $conn->prepare($sql);
                                $stmt->bindParam(':psc', $psc);
                                $stmt->bindParam(':ulice', $ulice);
                                $stmt->bindParam(':cisloPopisne', $cisloPopisne);
                                $stmt->bindParam(':mesto', $mesto);
                                $stmt->execute();

                                // Získání ID vložené adresy
                                $idAdresa = $conn->lastInsertId();

                                // Vložení osobních údajů
                                $sql = "INSERT INTO Osobni_udaje (jmeno, prijmeni, datumNarozeni, telefon, email, Adresa_idAdresa) VALUES (:jmeno, :prijmeni, :datumNarozeni, :telefon, :email, :Adresa_idAdresa)";
                                $stmt = $conn->prepare($sql);
                                $stmt->bindParam(':jmeno', $jmeno);
                                $stmt->bindParam(':prijmeni', $prijmeni);
                                $stmt->bindParam(':datumNarozeni', $datumNarozeni);
                                $stmt->bindParam(':telefon', $telefon);
                                $stmt->bindParam(':email', $email);
                                $stmt->bindParam(':Adresa_idAdresa', $idAdresa);
                                $stmt->execute();

                                // Získání ID vložených osobních údajů
                                $idOsobni_udaje = $conn->lastInsertId();

                                // Vložení přihlašovacích údajů
                                $sql = "INSERT INTO Prihlasovaci_udaje (login, heslo_hash, Prava_idPrava) VALUES (:login, :heslo_hash, :prava)";
                                $stmt = $conn->prepare($sql);
                                $stmt->bindParam(':login', $login);
                                $stmt->bindParam(':heslo_hash', $heslo_hash);
                                $stmt->bindParam(':prava', $prava);
                                $stmt->execute();

                                // Získání ID vložených přihlašovacích údajů
                                $idPrihlasovaci_udaje = $conn->lastInsertId();

                                // Vložení klienta
                                $sql = "INSERT INTO Klient (ico, Osobni_udaje_idOsobni_udaje, Prihlasovaci_udaje_idPrihlasovaci_udaje) VALUES (:ico, :idOsobni_udaje, :idPrihlasovaci_udaje)";
                                $stmt = $conn->prepare($sql);
                                $stmt->bindParam(':ico', $ico);
                                $stmt->bindParam(':idOsobni_udaje', $idOsobni_udaje);
                                $stmt->bindParam(':idPrihlasovaci_udaje', $idPrihlasovaci_udaje);
                                $stmt->execute();

                                // Potvrzení
                                $conn->commit();
                                return true;
                            } catch (PDOException $e) {
                                $conn->rollBack();
                                echo "Chyba při vkládání uživatele: " . $e->getMessage();
                                return false;
                            }
                        }

                        // Kontrola odeslání formuláře
                        if ($_SERVER["REQUEST_METHOD"] == "POST") {
                            // Zpracování formuláře
                            $jmeno = trim($_POST['jmeno']);
                            $prijmeni = trim($_POST['prijmeni']);
                            $datumNarozeni = $_POST['datumNarozeni'];
                            $telefon = trim($_POST['telefon']);
                            $email = trim($_POST['email']);
                            $psc = trim($_POST['psc']);
                            $ulice = trim($_POST['ulice']);
                            $cisloPopisne = trim($_POST['cisloPopisne']);
                            $mesto = trim($_POST['mesto']);

                            $errors = [];

                            // Validace jména
                            if (empty($jmeno)) {
                                $errors['jmeno'] = "Jméno je povinné pole.";
                            }

                            // Validace příjmení
                            if (empty($prijmeni)) {
                                $errors['prijmeni'] = "Příjmení je povinné pole.";
                            }

                            // Validace datumu narození
                            if (empty($datumNarozeni)) {
                                $errors['datumNarozeni'] = "Datum narození je povinné pole.";
                            }

                            // Validace telefonu
                            if (!preg_match("/^\d{9}$/", $telefon)) {
                                $errors['telefon'] = "Telefonní číslo musí být ve formátu 123456789.";
                            }

                            // Validace e-mailu
                            if (empty($email)) {
                                $errors['email'] = "E-mailová adresa je povinný údaj.";
                            } elseif (!filter_var($email, FILTER_VALIDATE_EMAIL)) {
                                $errors['email'] = "Zadaná e-mailová adresa není ve správném formátu.";
                            }

                            // Validace PSČ
                            if (empty($psc)) {
                                $errors['psc'] = "PSČ je povinné pole.";
                            } elseif (!preg_match("/^\d{5}$/", $psc)) {
                                $errors['psc'] = "PSČ musí být pětimístné číslo.";
                            }

                            // Validace ulice
                            if (empty($ulice)) {
                                $errors['ulice'] = "Ulice je povinné pole.";
                            }

                            // Validace příjmení
                            if (empty($cisloPopisne)) {
                                $errors['cisloPopisne'] = "Číslo popisné je povinné pole.";
                            }

                            // Validace datumu narození
                            if (empty($mesto)) {
                                $errors['mesto'] = "Město je povinné pole.";
                            }

                            // Pokud nejsou žádné chyby, pokračuje dál
                            if (empty($errors)) {
                                
                                // Kontrola existence uživatele
                                if (userExists($conn, $jmeno, $prijmeni, $datumNarozeni, $telefon, $email)) {
                                    echo "Uživatel již existuje.";
                                } else {
                                    // Generování loginu a hesla
                                    $login = generateRandomLogin($jmeno, $prijmeni, $conn);
                                    $genhesl = generateRandomPassword();
                                    $heslo_hash = password_hash($genhesl, PASSWORD_DEFAULT);
                                    $prava = 3;

                                    // Vložení uživatele do databáze
                                    if (insertUser($conn, $jmeno, $prijmeni, $datumNarozeni, $telefon, $email, $psc, $ulice, $cisloPopisne, $mesto, $login, $heslo_hash, $prava)) {
                                        echo "Uživatel úspěšně přidán.";

                                    // Sestavení obsahu emailu
                                    $subject = "Přihlašovací údaje do moto aplikace";
                                    $message = "Dobrý den,<br>
                                    níže Vám zasíláme Vaše přihlašovací údaje do moto aplikace:<br><br>
                                    
                                    \nLogin: $login <br>
                                    \nHeslo: $genhesl <br><br>
                                    
                                    Po úspěšném přihlášení si změňte heslo.<br>
                                    IS moto podpora";

                                        
                                        // Odeslání emailu
                                        if (sendEmail($email, $subject, $message)) {
                                            echo "Přihlašovací údaje byly odeslány na email.";
                                            // JavaScript pro přesměrování
                                            echo "<script>
                                                setTimeout(function(){
                                                    window.location.href = 'M_Addclient.php';
                                                }, 3000);
                                            </script>";
                                        } else {
                                            echo "Chyba při odesílání emailu.";
                                        }
                                    } else {
                                        echo "Chyba při přidávání uživatele.";
                                    }
                                }
                            } else {
                                foreach ($errors as $error) {
                                    echo $error . "<br>";
                                }
                            }
                        }
                        ?>
                        <div class="custom-frame">
                            <div class="row">
                                <div class="col-md-6">
                                    <div class="custom-frame">
                                        <div class="center">
                                            <form method="post" action="<?php echo htmlspecialchars($_SERVER["PHP_SELF"]); ?>">
                                                <div class="form-group row">
                                                    <label for="jmeno" class="col-sm-4 col-form-label"><b>Jméno:</b></label>
                                                    <div class="col-sm-8">
                                                        <input type="text" class="form-control" id="jmeno" name="jmeno" placeholder="Zadej jméno">
                                                    </div>
                                                </div>
                                                <div class="form-group row">
                                                    <label for="prijmeni" class="col-sm-4 col-form-label"><b>Příjmení:</b></label>
                                                    <div class="col-sm-8">
                                                        <input type="text" class="form-control" id="prijmeni" name="prijmeni" placeholder="Zadej příjmení">
                                                    </div>
                                                </div>
                                                <div class="form-group row">
                                                    <label for="datumNarozeni" class="col-sm-4 col-form-label"><b>Datum narození:</b></label>
                                                    <div class="col-sm-8">
                                                        <input type="date" class="form-control" id="datumNarozeni" name="datumNarozeni" placeholder="rrrr-mm-dd">
                                                    </div>
                                                </div>
                                                <div class="form-group row">
                                                    <label for="ico" class="col-sm-4 col-form-label"><b>ICO:</b></label>
                                                    <div class="col-sm-8">
                                                        <input type="text" class="form-control" id="ico" placeholder="Zadej IČO / nech prázdné">
                                                    </div>
                                                </div>
                                                <div class="form-group row">
                                                    <label for="email" class="col-sm-4 col-form-label"><b>Email:</b></label>
                                                    <div class="col-sm-8">
                                                        <input type="email" class="form-control" id="email" name="email" placeholder="Zadej email">
                                                    </div>
                                                </div>
                                                <div class="form-group row">
                                                    <label for="mobil" class="col-sm-4 col-form-label"><b>Mobil:</b></label>
                                                    <div class="col-sm-8">
                                                        <input type="text" class="form-control" id="mobil" name="telefon" placeholder="Zadej mobil">
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="col-md-6">
                                        <div class="custom-frame">
                                            <div class="center">
                                                <div class="form-group row">
                                                    <label for="mesto" class="col-sm-4 col-form-label"><b>Město:</b></label>
                                                    <div class="col-sm-8">
                                                        <input type="text" class="form-control" id="mesto" name="mesto" placeholder="Zadej město">
                                                    </div>
                                                </div>
                                                <div class="form-group row">
                                                    <label for="ulice" class="col-sm-4 col-form-label"><b>Ulice:</b></label>
                                                    <div class="col-sm-8">
                                                        <input type="text" class="form-control" id="ulice" name="ulice" placeholder="Zadej ulici">
                                                    </div>
                                                </div>
                                                <div class="form-group row">
                                                    <label for="cisloPopisne" class="col-sm-4 col-form-label"><b>Číslo popisné:</b></label>
                                                    <div class="col-sm-8">
                                                        <input type="text" class="form-control" id="cisloPopisne" name="cisloPopisne" placeholder="Zadej číslo popisné">
                                                    </div>
                                                </div>
                                                <div class="form-group row">
                                                    <label for="psc" class="col-sm-4 col-form-label"><b>PSČ:</b></label>
                                                    <div class="col-sm-8">
                                                        <input type="text" class="form-control" id="psc" name="psc" placeholder="Zadej PSČ">
                                                    </div>
                                                </div>
                                                <div class="row justify-content-center">
                                                    <button type="submit" class="btn btn-primary mb-3"><b>Přidat uživatele</b></button>
                                                </div>
                                            </form>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
                <?php
                function formatDatum($datum) {
                    $datum = preg_replace("/[^0-9]/", "", $datum);
                    $formattedDatum = "";
                    $length = strlen($datum);
                    
                    if ($length >= 4) {
                        $formattedDatum .= substr($datum, 0, 4) . "-";
                    }
                    if ($length >= 6) {
                        $formattedDatum .= substr($datum, 4, 2) . "-";
                    }
                    if ($length >= 8) {
                        $formattedDatum .= substr($datum, 6, 2);
                    }
                    
                    return $formattedDatum;
                }
                ?>
            <div class="col-lg-2 col-md-3 purple-bar">
                <div class="button-container">
                 <br>
                 <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='mechanik.php';">Domov</button>
                    <form method="post">
                     <button type="submit" name="logout" class="btn btn-danger mb-3">Odhlásit se</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
</body>
</html>
