<?php
include 'S_security.php';
?>

<?php
session_start();

$servername = '10.79.157.1:3306';
$username = 'root';
$password = '*****';
$dbname = 'moto_dilna_db';

try {
    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    // Odeslání formuláře pro přidání motocyklu
    if ($_SERVER["REQUEST_METHOD"] == "POST") {
        // Získání dat z formuláře
        $znacka_id = $_POST['znacka_id'];
        $model = $_POST['model'];
        $rokVyroby = $_POST['rokVyroby'];
        $VIN = $_POST['vin'];
        $platnostSTK = $_POST['platnostSTK'];
        $stavKM = $_POST['pocetKM'];
        $user_id = $_POST['user_id'];

        // Vložení nového motocyklu
        $stmt = $conn->prepare("INSERT INTO Motocykl (Znacka_idZnacka, model, rokVyroby, vin, platnostSTK, pocetKM, Klient_idKlient, foto) 
                                VALUES (:znacka_id, :model, :rokVyroby, :vin, :platnostSTK, :pocetKM, :user_id, 'https://latertakephoto.cz')");
        $stmt->bindParam(':znacka_id', $znacka_id);
        $stmt->bindParam(':model', $model);
        $stmt->bindParam(':rokVyroby', $rokVyroby);
        $stmt->bindParam(':vin', $VIN);
        $stmt->bindParam(':platnostSTK', $platnostSTK);
        $stmt->bindParam(':pocetKM', $stavKM);
        $stmt->bindParam(':user_id', $user_id);
        $stmt->execute();

        echo "<script>alert('Motocykl byl úspěšně přidán.');</script>";
        echo "<script>setTimeout(function(){ window.location.href = 'M_Addmoto.php'; }, 3000);</script>";
    }
} catch(PDOException $e) {
    echo "Připojení k databázi selhalo: " . $e->getMessage();
}
?>

<!DOCTYPE html>
<html lang="cs">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Přidání motocyklu</title>
  <link rel="icon" type="image/png" href="Photo.png">
  <link href="scss.css" rel="stylesheet" />
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>
<body>
    <div class="container-fluid">
        <div class="row">
            <div class="col-lg-2 col-md-3 purple-bar">
                <div class="button-container">
                  <br>
                  <button type="button" class="btn btn-primary mb-3" onclick="window.history.back();">Zpět</button>
                </div>
            </div>
            <div class="col-lg-8 col-md-8">
                <div class="middle-bar">
                    <div class="enter">
                        <div class="centered-text">
                            <div class="content">
                                <h1><b>Přidání motocyklu</b></h1>
                            </div>
                        </div>
                        <div class="custom-frame">  
                            <form method="post">
                                <div class="form-group row">
                                    <label for="znacka_id" class="col-sm-2 col-form-label"><b>Značka:</b></label>
                                    <div class="col-sm-10">
                                        <select id="znacka_id" name="znacka_id" class="form-control">
                                            <?php
                                            // Načtení značek
                                            $stmt = $conn->query("SELECT * FROM Znacka");
                                            while ($row = $stmt->fetch()) {
                                                echo "<option value='".$row['idZnacka']."'>".$row['nazev']."</option>";
                                            }
                                            ?>
                                        </select>
                                    </div>                          
                                </div>
                                <div class="form-group row">
                                    <label for="model" class="col-sm-2 col-form-label"><b>Model:</b></label>
                                    <div class="col-sm-10">
                                        <input type="text" id="model" name="model" class="form-control" required>
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <label for="rokVyroby" class="col-sm-2 col-form-label"><b>Rok výroby:</b></label>
                                    <div class="col-sm-10">
                                        <input type="text" id="rokVyroby" name="rokVyroby" class="form-control" required pattern="[0-9]{4}">
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <label for="VIN" class="col-sm-2 col-form-label"><b>VIN:</b></label>
                                    <div class="col-sm-10">
                                        <input type="text" id="VIN" name="vin" class="form-control" maxlength="17" minlength="17" required>
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <label for="platnostSTK" class="col-sm-2 col-form-label"><b>Platnost STK:</b></label>
                                    <div class="col-sm-10">
                                        <input type="text" id="platnostSTK" name="platnostSTK" class="form-control" placeholder="rrrr-mm-dd" required pattern="\d{4}-\d{2}-\d{2}" oninput="formatDateInput(event)">
                                    </div>
                                </div>
                                    <script>
                                        function formatDateInput(event) {
                                            let input = event.target;
                                            let value = input.value.replace(/\D/g, '');

                                            if (value.length > 8) {
                                                value = value.slice(0, 8);
                                            }

                                            let formattedValue = '';
                                            for (let i = 0; i < value.length; i++) {
                                                if (i === 4 || i === 6) {
                                                    formattedValue += '-';
                                                }
                                                formattedValue += value[i];
                                            }

                                            input.value = formattedValue;
                                        }
                                    </script>
                                <div class="form-group row">
                                    <label for="stavKM" class="col-sm-2 col-form-label"><b>Stav KM:</b></label>
                                    <div class="col-sm-10">
                                        <input type="text" id="stavKM" name="pocetKM" class="form-control" required pattern="[0-9]+">
                                    </div>
                                </div>
                                <div class="form-group row">
                                    <label for="selectOption" class="col-sm-2 col-form-label"><b>Uživatel:</b></label>
                                    <div class="col-sm-10">
                                        <select id="selectOption" name="user_id" class="form-control">
                                            <?php
                                            // Načtení uživatelů
                                            $stmt = $conn->query("SELECT Klient.idKlient, Osobni_udaje.jmeno, Osobni_udaje.prijmeni, Osobni_udaje.datumNarozeni, Osobni_udaje.idOsobni_udaje 
                                                                FROM Osobni_udaje 
                                                                JOIN Klient ON Osobni_udaje.idOsobni_udaje = Klient.Osobni_udaje_idOsobni_udaje 
                                                                WHERE Osobni_udaje.idOsobni_udaje > 3");
                                            while ($row = $stmt->fetch()) {
                                                echo "<option value='" . $row['idKlient'] . "'>" . $row['jmeno'] . " " . $row['prijmeni'] . " - " . $row['datumNarozeni'] . " / ID klienta: " . $row['idOsobni_udaje'] . "</option>";
                                            }
                                            ?>
                                        </select>
                                    </div>
                                </div>
                                <input type="hidden" id="idKlient" name="user_id" value="">
                                <script>
                                    document.getElementById("selectOption").addEventListener("change", function() {
                                        var user_id = this.value;
                                        document.getElementById("idKlient").value = user_id;
                                    });
                                </script>
                                <div class="centered-text">
                                    <button type="submit" class="btn btn-primary mb-3"><b>Přidat motocykl</b></button>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-lg-2 col-md-3 purple-bar">
                <div class="button-container">
                 <br>
                 <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='mechanik.php';">Domov</button>
                </div>
            </div>
        </div>
    </div>
</body>
</html>
