<?php
include 'S_security.php';

$servername = '10.79.157.1:3306';
$username = 'root';
$password = '*****';
$dbname = 'moto_dilna_db';

try {
    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    // Získání údajů pomocí idOsobni_udaje a VIN
    $idOsobni_udaje = $_GET['idOsobni_udaje'];
    $VIN = $_GET['VIN'];
    
    $sql_person = "SELECT * FROM Osobni_udaje WHERE idOsobni_udaje = :idOsobni_udaje";
    $stmt_person = $conn->prepare($sql_person);
    $stmt_person->bindParam(':idOsobni_udaje', $idOsobni_udaje);
    $stmt_person->execute();
    $row_person = $stmt_person->fetch(PDO::FETCH_ASSOC);

    $sql_motorcycle = "SELECT * FROM Motocykl WHERE vin = :vin";
    $stmt_motorcycle = $conn->prepare($sql_motorcycle);
    $stmt_motorcycle->bindParam(':vin', $VIN);
    $stmt_motorcycle->execute();
    $row_motorcycle = $stmt_motorcycle->fetch(PDO::FETCH_ASSOC);

    // Dotaz pro získání značky motocyklu
    $sql_brand = "SELECT nazev 
                  FROM Znacka
                  INNER JOIN Motocykl ON Motocykl.Znacka_idZnacka = Znacka.idZnacka
                  WHERE Motocykl.vin = :vin";
    $stmt_brand = $conn->prepare($sql_brand);
    $stmt_brand->bindParam(':vin', $VIN);
    $stmt_brand->execute();
    $row_brand = $stmt_brand->fetch(PDO::FETCH_ASSOC);

} catch(PDOException $e) {
    echo "Chyba při připojení k databázi: " . $e->getMessage();
}
?>

<!DOCTYPE html>
<html lang="cs">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Podrobný záznam servisu</title>
    <link rel="icon" type="image/png" href="Photo.png">
    <link href="scss.css" rel="stylesheet" />
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>
<body>
<div class="container-fluid">
    <div class="row">
        <div class="col-lg-2 col-md-3 purple-bar">
            <br>
            <div class="card">
                <div class="card-body">
                    <div class="custom-frame">
                        <img src="<?php echo $row_motorcycle['foto']; ?>" alt="Obrázek" class="img-fluid" width="230" height="160">
                        <br>
                        <b>Značka:</b> <?php echo $row_brand['nazev']; ?><br>
                        <b>Model:</b> <?php echo $row_motorcycle['model']; ?><br>
                        <b>VIN:</b> <?php echo $row_motorcycle['vin']; ?><br>
                        <b>Rok výroby:</b> <?php echo $row_motorcycle['rokVyroby']; ?><br>
                        <b>Stav KM:</b> <span id="stavKM"><?php echo $row_motorcycle['pocetKM']; ?></span>
                        <input type="text" id="editStavKM" style="display: none;" value="<?php echo $row_motorcycle['pocetKM']; ?>"><br>
                        <b>Platnost STK:</b> <span id="platnostSTK"><?php echo $row_motorcycle['platnostSTK']; ?></span>
                        <input type="text" id="editPlatnostSTK" style="display: none;" value="<?php echo $row_motorcycle['platnostSTK']; ?>"><br>
                    </div>
                </div>
            </div>
            <br>
            <div class="card">
                <div class="card-body">
                    <b>Jméno a příjmení</b><br>
                    <input type="text" id="jmeno" value="<?php echo $row_person['jmeno'] . ' ' . $row_person['prijmeni']; ?>" readonly><br>
                    <b>Datum narození</b><br>
                    <input type="date" id="datum" value="<?php echo $row_person['datumNarozeni']; ?>" readonly><br>
                    <b>Email</b><br>
                    <input type="email" id="email" value="<?php echo $row_person['email']; ?>" readonly><br>
                    <b>Mobil</b><br>
                    <input type="telefon" id="telefon" value="<?php echo $row_person['telefon']; ?>" readonly><br>
                </div>
            </div>
            <br>
            <div class="button-container">
            <button type="button" class="btn btn-primary mb-3" onclick="window.history.back();">Zpět</button>
            </div>
        </div>
        <div class="col-lg-8 col-md-8">
            <div class="middle-bar">
                    <div class="centered-text">
                        <br><h1><b>Podrobný záznam servisu</b></h1>
                        <div class="container">
                            <div class="info-scrollable">
                                <div class="container"> 
                                <?php

                                    $servername = '10.79.157.1:3306';
                                    $username = 'root';
                                    $password = '*****';
                                    $dbname = 'moto_dilna_db';

                                    try {
                                        // Dotaz na fotografie a události
                                        $sql_photos_events = "SELECT Udalost.idUdalost, Udalost.nazevudalosti, Udalost.datumZahajeni, Udalost.datumUkonceni, Udalost.poznamky,  Udalost.podrobnosti, GROUP_CONCAT(Udalost.fotky) AS fotky
                                                            FROM Udalost
                                                            WHERE Udalost.Motocykl_idMotocykl = (SELECT idMotocykl FROM Motocykl WHERE vin = :vin)
                                                            GROUP BY Udalost.idUdalost";
                                        $stmt_photos_events = $conn->prepare($sql_photos_events);
                                        $stmt_photos_events->bindParam(':vin', $VIN);
                                        $stmt_photos_events->execute();
                                        $result_photos_events = $stmt_photos_events->fetchAll(PDO::FETCH_ASSOC);

                                        foreach ($result_photos_events as $row_photos_events) {
                                            echo '<div class="row">
                                                    <div class="col-xs-12 col-sm-6 col-md-4 text-center border d-flex flex-column justify-content-center align-items-center">';
                                            
                                            // Dotaz na získání loginu uživatele
                                            $sql_login = "SELECT Prihlasovaci_udaje.login
                                                        FROM Osobni_udaje
                                                        JOIN Klient ON Osobni_udaje.idOsobni_udaje = Klient.Osobni_udaje_idOsobni_udaje
                                                        JOIN Prihlasovaci_udaje ON Klient.Prihlasovaci_udaje_idPrihlasovaci_udaje = Prihlasovaci_udaje.idPrihlasovaci_udaje
                                                        WHERE Osobni_udaje.idOsobni_udaje = :idOsobni_udaje";
                                            $stmt_login = $conn->prepare($sql_login);
                                            $stmt_login->bindParam(':idOsobni_udaje', $idOsobni_udaje);
                                            $stmt_login->execute();
                                            $row_login = $stmt_login->fetch(PDO::FETCH_ASSOC);
                                            
                                            // Načtení loginu uživatele
                                            $login = $row_login['login'];

                                            // Adresa složky s fotkami
                                            $idUdalost = $row_photos_events['idUdalost'];
                                            $photosFolder = "images/{$login}/{$idUdalost}/";

                                            // Zkontroluje existenci složky
                                            if (is_dir($photosFolder)) {
                                                // Získání seznamu souborů ve složce
                                                $files = scandir($photosFolder);
                                                echo '<div class="row mb-3">';
                                                foreach ($files as $file) {
                                                    if ($file === '.' || $file === '..') continue;

                                                    // Vytvoření úplné cesty k souboru
                                                    $photoPath = $photosFolder . $file;

                                                    // Vytvoření odkazu na fotografii
                                                    echo '<div class="col" style="margin-bottom: 1px;">
                                                        <a href="' . $photoPath . '" data-lightbox="photos">
                                            <img src="' . $photoPath . '" alt="Photo" class="img-fluid" width="60" height="100"></a>
                                            <button type="button" class="btn btn-danger mb-3" style="padding: 8px 8px; font-size: 6px;" onclick="removePhoto(' . $row_photos_events['idUdalost'] . ', \'' . $row_login['login'] . '\', \'' . htmlspecialchars($file, ENT_QUOTES) . '\')">Odebrat fotku</button>
                                            </div>';
                                                }
                                                echo '</div>';
                                            echo '<div class="card">    
                                            <form action="" method="post" enctype="multipart/form-data">
                                                <input type="file" name="fileToUpload[]" id="fileToUpload" style="padding: 5px 0px; font-size: 10px;" multiple>
                                                <input type="submit" value="Nahrát fotku" name="submit" style="padding: 5px 5px; font-size: 10px;">
                                            </form>
                                            </div>
                                            <br>';    
                                            } else {
                                                echo "Fotodokumentace nebyla doposud vložena!";
                                                echo "<br>";
                                                echo "<br>";
                                                echo "<br>";
                                                echo '<div class="card">    
                                            <form action="" method="post" enctype="multipart/form-data">
                                                <input type="file" name="fileToUpload[]" id="fileToUpload" style="padding: 5px 0px; font-size: 10px;" multiple>
                                                <input type="submit" value="Nahrát fotku" name="submit" style="padding: 5px 5px; font-size: 10px;">
                                            </form>
                                            </div>';
                                            }

                                            // Vypsání událostí
                                            echo '</div>
                                                <div class="col-xs-12 col-sm-6 col-md-8 text-center border d-flex flex-column justify-content-center align-items-center">
                                                <b><i>Název události: </i>' . $row_photos_events['nazevudalosti'] . '</b>
                                                <b><i>Datum zahájení: </i>' . $row_photos_events['datumZahajeni'] . '</b>
                                                <b><i>Datum ukončení: </i>' . $row_photos_events['datumUkonceni'] . '</b>
                                                <b><i>Poznámky: </i>' . $row_photos_events['poznamky'] . '</b><br>
                                                    <b>' . $row_photos_events['podrobnosti'] . '</b><br>
                                                        <div class="row">
                                                            <div class="mr-2">
                                                            <button type="button" class="btn btn-success mb-3" style="padding: 10px 5px; font-size: 10px;" onclick="editEvent(' . $row_photos_events['idUdalost'] . ', \'' . $row_photos_events['podrobnosti'] . '\')">Upravit podrobnosti</button>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>';
                                        }
                                    } catch(PDOException $e) {
                                        echo "Chyba při načítání dat: " . $e->getMessage();
                                    }
                                    ?>
                                    </div>
                                </div>
                            </div>
                        </div>              
                    </div>
                </div>
                <!-- Připojení lightbox knihovny -->
                <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/lightbox2/2.11.3/css/lightbox.min.css">
                <script src="https://cdnjs.cloudflare.com/ajax/libs/lightbox2/2.11.3/js/lightbox.min.js"></script>
                <div class="col-lg-2 col-md-3 purple-bar">
                    <div class="button-container">
                     <br>
                     <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='mechanik.php';">Domov</button>
                        <form method="post">
                        <button type="submit" name="logout" class="btn btn-danger mb-3">Odhlásit se</button>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>
</html>
<script>
    // Úprava podrobností události
    function editEvent(idUdalost, podrobnosti) {
        var newPodrobnosti = prompt("Zadejte nové podrobnosti:", podrobnosti);
        if (newPodrobnosti !== null) {
            // Volání PHP skriptu pro aktualizaci podrobností v databázi pomocí AJAX
            var formData = new FormData();
            formData.append('idUdalost', idUdalost);
            formData.append('podrobnosti', newPodrobnosti);

            // Odeslání formuláře na server pomocí AJAX
            fetch('S_Update_Podrobnosti.php', {
                method: 'POST',
                body: formData
            })
            .then(response => {
                if (response.ok) {
                    location.reload();
                } else {
                    throw new Error('Chyba při ukládání údajů');
                }
            })
            .catch(error => {
                alert(error.message);
            });
        }
    }
</script>
<?php

$servername = '10.79.157.1:3306';
$username = 'root';
$password = '*****';
$dbname = 'moto_dilna_db';

try {
    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    // IF pro nahrání fotek
    if (isset($_POST["submit"])) {
        // Získání ID události
        $login = $row_login['login'];
        $idUdalost = $row_photos_events['idUdalost'];

        if ($idUdalost) {
            // Adresář pro událost
            $udalDir = "images/{$login}/{$idUdalost}/";

            // Vytvoření adresáře, pokud neexistuje
            if (!is_dir($udalDir)) {
                mkdir($udalDir, 0777, true);
            }

            // Zpracování všech nahraných fotek
foreach ($_FILES['fileToUpload']['tmp_name'] as $key => $tmp_name) {
    // Získání cesty k nahrávanému souboru
    $sourceFile = $_FILES['fileToUpload']['tmp_name'][$key];
    // Získání názvu souboru
    $fileName = $_FILES['fileToUpload']['name'][$key];
    // Vytvoření cílového umístění souboru
    $targetFile = $udalDir . basename($fileName);

    if (move_uploaded_file($sourceFile, $targetFile)) {
    } else {
        echo "Nahrávání souboru $fileName selhalo.";
    }
}
        } else {
            echo "ID události není k dispozici.";
        }
    }
} catch (PDOException $e) {
    echo "Chyba při připojení k databázi: " . $e->getMessage();
} finally {
    $conn = null;
}
?>
<script>
function removePhoto(idUdalost, login, file) {
    var confirmation = confirm('Opravdu chcete smazat tuto fotografii?');
    if (confirmation) {
        fetch('S_delete_photo.php', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/x-www-form-urlencoded'
            },
            body: 'idUdalost=' + encodeURIComponent(idUdalost) + '&login=' + encodeURIComponent(login) + '&file=' + encodeURIComponent(file)
        })
        .then(response => response.text())
        .then(text => {
            alert(text);
            location.reload();
        })
        .catch(error => {
            console.error('Chyba:', error);
        });
    }
}
</script>
</body>
</html>
