<?php
include 'S_security.php';

$servername = '10.79.157.1:3306';
$username = 'root';
$password = '*****';
$dbname = 'moto_dilna_db';

try {
    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    // Požadavek na odhlášení
    if (isset($_POST['logout'])) {
        logout();
    }

    // Získání údajů pomocí idOsobni_udaje a VIN
    if (isset($_GET['idOsobni_udaje'], $_GET['VIN'])) {
        $idOsobni_udaje = $_GET['idOsobni_udaje'];
        $VIN = $_GET['VIN'];

        // Dotaz na osobní údaje
        $sql_person = "SELECT * FROM Osobni_udaje WHERE idOsobni_udaje = :idOsobni_udaje";
        $stmt_person = $conn->prepare($sql_person);
        $stmt_person->bindParam(':idOsobni_udaje', $idOsobni_udaje);
        $stmt_person->execute();
        $row_person = $stmt_person->fetch(PDO::FETCH_ASSOC);

        // Dotaz na motocykl
        $sql_motorcycle = "SELECT * FROM Motocykl WHERE vin = :vin";
        $stmt_motorcycle = $conn->prepare($sql_motorcycle);
        $stmt_motorcycle->bindParam(':vin', $VIN);
        $stmt_motorcycle->execute();
        $row_motorcycle = $stmt_motorcycle->fetch(PDO::FETCH_ASSOC);

        // Dotaz na značku motocyklu
        $sql_brand = "SELECT nazev FROM Znacka INNER JOIN Motocykl ON Motocykl.Znacka_idZnacka = Znacka.idZnacka WHERE Motocykl.vin = :vin";
        $stmt_brand = $conn->prepare($sql_brand);
        $stmt_brand->bindParam(':vin', $VIN);
        $stmt_brand->execute();
        $row_brand = $stmt_brand->fetch(PDO::FETCH_ASSOC);
    } else {
        exit("Chybějící parametry v URL.");
    }
} catch (PDOException $e) {
    echo "Chyba při připojení k databázi: " . $e->getMessage();
} finally {
    $conn = null;
}
?>

<?php

$servername = '10.79.157.1:3306';
$username = 'root';
$password = '*****';
$dbname = 'moto_dilna_db';

try {
    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    $idOsobni_udaje = $_GET['idOsobni_udaje'];
    $VIN = $_GET['VIN'];

     // Vytvoření adresáře, pokud neexistuje
     function createDirectory($path) {
        if (!is_dir($path)) {
            mkdir($path, 0777, true);
        }
    }

    // Nahrání souboru
    function uploadFile($file, $targetDir, $targetFile) {
        if (move_uploaded_file($file["tmp_name"], $targetFile)) {
            return true;
        } else {
            return false;
        }
    }

    // IF pro zpracování formuláře nahrání fotky
    if (isset($_POST["submit"])) {
        // Získání VIN z URL adresy
        $VIN = $_GET['VIN'];

        // Získání loginu uživatele z databáze
        $sql = "SELECT Prihlasovaci_udaje.login
        FROM Osobni_udaje
        JOIN Klient ON Osobni_udaje.idOsobni_udaje = Klient.Osobni_udaje_idOsobni_udaje
        JOIN Prihlasovaci_udaje ON Klient.Prihlasovaci_udaje_idPrihlasovaci_udaje = Prihlasovaci_udaje.idPrihlasovaci_udaje
        WHERE Osobni_udaje.idOsobni_udaje = :idOsobni_udaje";
        $stmt = $conn->prepare($sql);
        $stmt->bindParam(':idOsobni_udaje', $idOsobni_udaje);
        $stmt->execute();
        $result = $stmt->fetch(PDO::FETCH_ASSOC);

        if ($result) {
            $login = $result["login"];

            // Adresář pro uživatele
            $userDir = "images/$login/";

            // Vytvořit adresář, pokud neexistuje
            createDirectory($userDir);

            // Soubor pro uložení
            $targetFile = $userDir . "ALFA_" . $VIN . ".jpg";

            // Nahrát soubor
            if (uploadFile($_FILES["fileToUpload"], $userDir, $targetFile)) {
                // Aktualizovat cestu k fotce v databázi
                $sql = "UPDATE Motocykl SET foto = :targetFile WHERE vin = :VIN";
                $stmt = $conn->prepare($sql);
                $stmt->bindParam(':targetFile', $targetFile);
                $stmt->bindParam(':VIN', $VIN);
                if ($stmt->execute()) {
                    echo "Fotka byla úspěšně nahrána.";
                } else {
                    echo "Chyba při aktualizaci cesty k fotce v databázi.";
                }
            } else {
                echo "Nahrávání souboru selhalo.";
            }
        } else {
            echo "Uživatel s tímto VIN nebyl nalezen.";
        }
    }
} catch (PDOException $e) {
    echo "Chyba při připojení k databázi: " . $e->getMessage();
} finally {
    $conn = null;
}
?>


<!DOCTYPE html>
<html lang="cs">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Úprava motocyklu</title>
    <link rel="icon" type="image/png" href="Photo.png">
    <link href="scss.css" rel="stylesheet" />
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>
<body>
<div class="container-fluid">
    <div class="row">
        <div class="col-lg-2 col-md-3 purple-bar">
            <br>
            <div class="card">
                <div class="card-body">
                    <h5><b><?php echo $row_brand['nazev']; ?></b></h5>
                    <img src="<?php echo $row_motorcycle['foto']; ?>" alt="Obrázek" class="img-fluid" width="230" height="160">
                    <br>
                    <br><b><i>Nahrát fotku motocyklu</b></i>            
                    <form action="" method="post" enctype="multipart/form-data">
                        <input type="file" name="fileToUpload" id="fileToUpload" style="padding: 5px 0px; font-size: 10px;">
                        <input type="submit" value="Nahrát fotku" name="submit" style="padding: 5px 9px; font-size: 10px;">
                    </form>
                </div>
            </div>
            <br>
            <div class="card">
                <div class="card-body">
                    <b>Jméno a příjmení</b><br>
                    <input type="text" id="jmeno" value="<?php echo $row_person['jmeno'] . ' ' . $row_person['prijmeni']; ?>" readonly><br>
                    <b>Datum narození</b><br>
                    <input type="date" id="datum" value="<?php echo $row_person['datumNarozeni']; ?>" readonly><br>
                    <b>Email</b><br>
                    <input type="email" id="email" value="<?php echo $row_person['email']; ?>" readonly><br>
                    <b>Mobil</b><br>
                    <input type="telefon" id="telefon" value="<?php echo $row_person['telefon']; ?>" readonly><br>
                </div>
            </div>
            <br>
            <div class="button-container">

            <?php
                $servername = '10.79.157.1:3306';
                $username = 'root';
                $password = '*****';
                $dbname = 'moto_dilna_db';

                // Pokud byl odeslán požadavek na smazání motocyklu
                if(isset($_POST['delete'])) {
                    // Získání VIN z URL adresy
                    $VIN = $_GET['VIN'];

                    try {
                        $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
                        $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

                        // Získání idMotocyklu podle VIN
                        $stmt = $conn->prepare("SELECT idMotocykl FROM Motocykl WHERE vin = :vin");
                        $stmt->bindParam(':vin', $VIN);
                        $stmt->execute();
                        $row = $stmt->fetch(PDO::FETCH_ASSOC);
                        $idMotocyklu = $row["idMotocykl"];

                        if ($idMotocyklu) {
                            // Smazání přiřazených událostí
                            $stmt = $conn->prepare("DELETE FROM Udalost WHERE Motocykl_idMotocykl = :idMotocyklu");
                            $stmt->bindParam(':idMotocyklu', $idMotocyklu);
                            if ($stmt->execute()) {
                                // Smazání motocyklu
                                $stmt = $conn->prepare("DELETE FROM Motocykl WHERE vin = :vin");
                                $stmt->bindParam(':vin', $VIN);
                                if ($stmt->execute()) {
                                    // JavaScript pro přesměrování na stránku mechanik.php
                                    echo "<script>window.location.href = 'mechanik.php';</script>";
                                    exit();
                                } else {
                                    echo "Chyba při mazání motocyklu: " . $stmt->errorInfo()[2];
                                }
                            } else {
                                echo "Chyba při mazání událostí: " . $stmt->errorInfo()[2];
                            }
                        } else {
                            echo "Motocykl s tímto VIN nebyl nalezen.";
                        }
                    } catch(PDOException $e) {
                        echo "Chyba při připojení k databázi: " . $e->getMessage();
                    }
                    $conn = null;
                }
            ?>

            <!-- Skript pro zobrazení potvrzovacího dialogu a volání PHP skriptu pro smazání -->
            <script>
                function confirmDelete() {
                    if(confirm("Opravdu chcete motocykl a všechny jeho přiřazené události smazat z databáze?")) {
                        document.getElementById("deleteForm").submit();
                    }
                }
            </script>
            <!-- Formulář pro odeslání požadavku na smazání motocyklu -->
            <form id="deleteForm" method="post">
                <input type="hidden" name="delete" value="1">
                <button type="button" class="btn btn-primary mb-3" onclick="confirmDelete()">Smazat</button>
            </form>
                <button type="button" class="btn btn-primary mb-3" onclick="window.history.back();">Zpět</button>
            </div>
        </div>
        <div class="col-lg-8 col-md-8">
            <div class="middle-bar">
                <div class="enter">
                    <div class="centered-text">
                        <div class="content">
                            <div class="card">
                                <div class="card-body">
                                    <b><p style="font-size: 25px;">Specifikace motocyklu</p></b>
                                    <b>Značka:</b> <?php echo $row_brand['nazev']; ?><br>
                                    <b>Model:</b> <?php echo $row_motorcycle['model']; ?><br>
                                    <b>VIN:</b> <?php echo $row_motorcycle['vin']; ?><br>
                                    <b>Rok výroby:</b> <?php echo $row_motorcycle['rokVyroby']; ?><br>
                                    <b>Stav KM:</b> <span id="stavKM"><?php echo $row_motorcycle['pocetKM']; ?></span>
                                    <input type="text" id="editStavKM" style="display: none;" value="<?php echo $row_motorcycle['pocetKM']; ?>"><br>
                                    <b>Platnost STK:</b> <span id="platnostSTK"><?php echo $row_motorcycle['platnostSTK']; ?></span>
                                    <input type="text" id="editPlatnostSTK" style="display: none;" value="<?php echo $row_motorcycle['platnostSTK']; ?>"><br>
                                    <br>
                                    <button type="button" class="btn btn-primary mb-3" onclick="<?php echo "window.location.href = 'M_Moto_photo.php?VIN=" . urlencode($VIN) . "&idOsobni_udaje=" . urlencode($idOsobni_udaje) . "'"; ?>">Podrobný servis a historie</button>
                                    <div><?php /*
                                     // Získání iformací o uživateli
                                     $idOsobni_udaje = $_GET['idOsobni_udaje'];
                                     $VIN = $_GET['VIN'];

                                     echo "<button type='button' class='btn-lg mb-4 text-center' onclick=\"redirectToMotoupgrade('$VIN', '$idOsobni_udaje')\">";
                                     echo "<img src='C:\\Users\\darig\\Desktop\\Nová složka\\Photo.png' alt='motorcycle' width='190' height='130'>";
                                     echo "<br><b>VIN:</b> " . $VIN . "</br>"; // Pouze $VIN, protože už je ve formě jednoduché proměnné, ne pole
                                     echo "<!-- idOsobni_udaje: " . $idOsobni_udaje . " -->";
                                     echo "</button>";
                                     ?>

                                     <script>
                                        function redirectToMotoupgrade(vin, idOsobni_udaje) {
                                        // Přesměrování na stránku M_Motoupgrade.php s parametry VIN a idOsobni_udaje v URL
                                        window.location.href = 'M_Motoupgrade.php?VIN=' + encodeURIComponent(vin) + '&idOsobni_udaje=' + encodeURIComponent(idOsobni_udaje);
                                        }
                                     </script>
                                    */ ?>
                                    </div>
                                </div>
                            </div>
                            <br>
                            <div class="row">
                                <div class="col-md-12">
                                    <div class="card">
                                        <div class="card-body">
                                            <h5 class="card-title">Kalendář akcí</h5>
                                            <div class="eneter">
                                                <div class="scrollable">
                                              <div class="card">
                                                <div class="card-body">
                                                  <?php
                                                  try {
                                                      $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
                                                      $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

                                                      // Získání potřebných údajů pomocí VIN
                                                      $VIN = $_GET['VIN'];

                                                      // Dotaz na události pro daný motocykl na základě jeho VIN
                                                      $sql_events = "SELECT * FROM Udalost INNER JOIN Motocykl ON Udalost.Motocykl_idMotocykl = Motocykl.idMotocykl WHERE Motocykl.vin = :vin";
                                                      $stmt_events = $conn->prepare($sql_events);
                                                      $stmt_events->bindParam(':vin', $VIN);
                                                      $stmt_events->execute();
                                                      $events = $stmt_events->fetchAll(PDO::FETCH_ASSOC);

                                                  } catch(PDOException $e) {
                                                      echo "Chyba při připojení k databázi: " . $e->getMessage();
                                                  }
                                                  ?>

                                                  <?php if (!empty($events)): ?>
                                                      <?php foreach ($events as $event): ?>
                                                          <h5 class="card-title"><b>Servis:</b> <u><?php echo $event['nazevUdalosti']; ?></u></h5>
                                                          <p><b>Datum zahájení:</b> <?php echo $event['datumZahajeni']; ?></p>
                                                          <p><b>Datum ukončení:</b> <?php echo $event['datumUkonceni']; ?></p>
                                                          <p><b>Poznámky:</b> <?php echo $event['poznamky']; ?></p>
                                                          <p><b>Datum vytvoření:</b> <?php echo $event['datumVytvoreni']; ?></p>
                                                          <hr>
                                                      <?php endforeach; ?>
                                                  <?php else: ?>
                                                      <p>Pro tento motocykl nejsou žádné události.</p>
                                                  <?php endif; ?>
                                                </div>
                                              </div>
                                              </div>
                                              </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="col-lg-2 col-md-3 purple-bar">
            <div class="button-container">
                <br>
                <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='mechanik.php';">Domov</button>
                <form method="post">
                    <button type="submit" name="logout" class="btn btn-danger mb-3">Odhlásit se</button>
                </form>
            </div>
        </div>
    </div>
</div>

</body>
</html>
