<?php

session_start();

$servername = '10.79.157.1:3306';
$username = 'root';
$password = '*****';
$dbname = 'moto_dilna_db';

// Ošetření vstupů
if(isset($_POST['newPassword'])) {
    $newPassword = $_POST['newPassword'];
    // Převedení nového hesla na hash
    $hashedPassword = password_hash($newPassword, PASSWORD_DEFAULT);
} else {
    echo "Nové heslo nebylo zadáno.";
    exit();
}

// Načtení user_id z relace
if(isset($_SESSION['user_id'])) {
    $userId = $_SESSION['user_id'];
} else {
    echo "ID klienta není nastaveno v relaci.";
    exit();
}

try {
    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    // Získání idPrihlasovaci_udaje klienta na základě jeho user_id
    $stmt_klient = $conn->prepare("SELECT Prihlasovaci_udaje_idPrihlasovaci_udaje FROM Klient WHERE idKlient = :user_id");
    $stmt_klient->bindParam(':user_id', $userId);
    $stmt_klient->execute();
    $row_klient = $stmt_klient->fetch(PDO::FETCH_ASSOC);

    // Pokud nebyl nalezen záznam o klientovi, skončí
    if (!$row_klient) {
        echo "Záznam o klientovi nebyl nalezen.";
        exit();
    }

    // Získání idPrihlasovaci_udaje klienta
    $idPrihlasovaciUdaje = $row_klient['Prihlasovaci_udaje_idPrihlasovaci_udaje'];

    // Připravený dotaz pro aktualizaci hesla uživatele
    $stmt = $conn->prepare("UPDATE Prihlasovaci_udaje SET heslo_hash = :password WHERE idPrihlasovaci_udaje = :idPrihlasovaci_udaje");
    $stmt->bindParam(':password', $hashedPassword);
    $stmt->bindParam(':idPrihlasovaci_udaje', $idPrihlasovaciUdaje);
    $stmt->execute();

    // Přesměrování na původní stránku po 3 vteřinách
    echo "<script>
    alert('Heslo bylo úspěšně změněno');
    setTimeout(function() {
        window.location.href = 'C_Client.php';
    }, 1000);
    </script>";
} catch(PDOException $e) {
    echo "Chyba při zpracování požadavku: " . $e->getMessage();
}
?>
