<?php
// Spuštění relace
session_start();

// Kontrola, zda je uživatel přihlášen
if (!isset($_SESSION['loggedin']) || $_SESSION['loggedin'] !== true) {
    // Pokud uživatel není přihlášen, přesměrujte ho na přihlašovací stránku
    header("location: index.php");
    exit;
}

// Kontrola, zda uživatel má odpovídající práva přístupu k této stránce
if ($_SESSION['role'] !== 'klient') {
    unauthorizedAccessRedirect();
}

// Pokračování v zobrazování chráněné stránky
$username = $_SESSION['username'];

// Pokud je odeslán požadavek na odhlášení
if (isset($_POST['logout'])) {
    performLogout();
}

/**
 * Funkce pro přesměrování při neoprávněném přístupu
 */
function unauthorizedAccessRedirect() {
    echo "Nejste oprávněn k přístupu na tuto stránku!!!";
    echo "<br>";
    echo "Budete přesměrování na domovskou stránku za 5 sekund.";

    // Spustit odpočet na 5 sekund
    echo '<meta http-equiv="refresh" content="5;url=https://dilna.rigldavid.fun">';
    exit;
}

/**
 * Funkce pro odhlášení uživatele
 */
function performLogout() {

    session_unset(); // Vymaže všechny proměnné relace
    session_destroy(); // Zruší relaci

    // Přesměrování na úvodní stránku po odhlášení
    header("Location: index.php");
    exit(); // Zajištění, aby se kód dále neprováděl po přesměrování
}
?>