<?php

session_start();

$servername = '10.79.157.1:3306';
$username = 'root';
$password = '*****';
$dbname = 'moto_dilna_db';

// Ošetření vstupů
if(isset($_POST['newPassword'])) {
    $newPassword = $_POST['newPassword'];
    // Převedení nového hesla na hash
    $hashedPassword = password_hash($newPassword, PASSWORD_DEFAULT);
} else {
    echo "Nové heslo nebylo zadáno.";
    exit();
}

// Načtení mechanik_id z relace
if(isset($_SESSION['mechanik_id'])) {
    $mechanikId = $_SESSION['mechanik_id'];
} else {
    echo "ID mechanika není nastaveno v relaci.";
    exit();
}

try {
    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    // Získání idPrihlasovaci_udaje mechanika na základě jeho mechanik_id
    $stmt_mechanik = $conn->prepare("SELECT Prihlasovaci_udaje_idPrihlasovaci_udaje FROM Mechanik WHERE idMechanik = :mechanik_id");
    $stmt_mechanik->bindParam(':mechanik_id', $mechanikId);
    $stmt_mechanik->execute();
    $row_mechanik = $stmt_mechanik->fetch(PDO::FETCH_ASSOC);

    // Pokud nebyl nalezen záznam o mechanikovi, skončí
    if (!$row_mechanik) {
        echo "Záznam o mechanikovi nebyl nalezen.";
        exit();
    }

    // Získání idPrihlasovaci_udaje mechanika
    $idPrihlasovaciUdaje = $row_mechanik['Prihlasovaci_udaje_idPrihlasovaci_udaje'];

    // Připravený dotaz pro aktualizaci hesla uživatele
    $stmt = $conn->prepare("UPDATE Prihlasovaci_udaje SET heslo = :password WHERE idPrihlasovaci_udaje = :idPrihlasovaci_udaje");
    $stmt->bindParam(':password', $hashedPassword);
    $stmt->bindParam(':idPrihlasovaci_udaje', $idPrihlasovaciUdaje);
    $stmt->execute();

    // Přesměrování na původní stránku po 3 vteřinách
    echo "<script>
    alert('Heslo bylo úspěšně změněno');
    setTimeout(function() {
        window.location.href = 'mechanik.php';
    }, 1000);
    </script>";
} catch(PDOException $e) {
    echo "Chyba při zpracování požadavku: " . $e->getMessage();
}
?>