
<?php

require '/home/vendor/autoload.php';

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception;

// Funkce pro odeslání e-mailu
function sendEmail($to, $subject, $message) {
    $mail = new PHPMailer(true);

    try {
      $mail->isSMTP();
      $mail->Host = 'smtp.seznam.cz';
      $mail->SMTPAuth = true;
      $mail->Username = 'infomoto@rigldavid.fun';
      $mail->Password = '*****';
      $mail->SMTPSecure = 'ssl';
      $mail->Port = 465;

        $mail->CharSet = 'UTF-8';

        $mail->setFrom('infomoto@rigldavid.fun', 'Moto dilna DP');
        $mail->addAddress($to);

        // Obsah emailu
        $mail->isHTML(true);
        $mail->Subject = $subject;
        $mail->Body = $message;

        // Odeslání emailu
        $mail->send();
        return true;
    } catch (Exception $e) {
        error_log($mail->ErrorInfo);
        echo "Chyba při odesílání emailu: " . $mail->ErrorInfo;
        return false;
    }
}
?>
<?php

$servername = '10.79.157.1:3306';
$username = 'root';
$password = '*****';
$dbname = 'moto_dilna_db';

try {
    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
} catch(PDOException $e) {
    echo "Chyba při připojování k databázi: " . $e->getMessage();
}

// Funkce pro kontrolu existence uživatele v databázi
function userExists($conn, $jmeno, $prijmeni, $datumNarozeni, $telefon, $email) {
    $sql = "SELECT * FROM Osobni_udaje WHERE jmeno = :jmeno AND prijmeni = :prijmeni AND datumNarozeni = :datumNarozeni AND telefon = :telefon AND email = :email";
    $stmt = $conn->prepare($sql);
    $stmt->bindParam(':jmeno', $jmeno);
    $stmt->bindParam(':prijmeni', $prijmeni);
    $stmt->bindParam(':datumNarozeni', $datumNarozeni);
    $stmt->bindParam(':telefon', $telefon);
    $stmt->bindParam(':email', $email);
    $stmt->execute();
    return $stmt->rowCount() > 0;
}

function generateRandomLogin($jmeno, $prijmeni, $conn) {
    // Převod příjmení na malá písmena
    $prijmeniLowerCase = mb_strtolower($prijmeni, 'UTF-8');
    // Odstranění diakritiky z příjmení
    $prijmeniWithoutDiacritics = removeAccents($prijmeniLowerCase);
    // Přidání prvního písmene jména
    $login = $prijmeniWithoutDiacritics . substr(strtolower($jmeno), 0, 1);
    
    // Pokud již login existuje, přidá se číslo na konec
    $suffix = '';
    while (loginExists($conn, $login . $suffix)) {
        if ($suffix === '') {
            $suffix = 1;
        } else {
            $suffix++;
        }
        $login = $prijmeniWithoutDiacritics . substr(strtolower($jmeno), 0, 1) . $suffix;
    }
    
    return $login;
}

function removeAccents($string) {
    $accents = array('á', 'č', 'ď', 'é', 'ě', 'í', 'ň', 'ó', 'ř', 'š', 'ť', 'ú', 'ů', 'ý', 'ž', 'Á', 'Č', 'Ď', 'É', 'Ě', 'Í', 'Ň', 'Ó', 'Ř', 'Š', 'Ť', 'Ú', 'Ů', 'Ý', 'Ž');
    $without = array('a', 'c', 'd', 'e', 'e', 'i', 'n', 'o', 'r', 's', 't', 'u', 'u', 'y', 'z', 'A', 'C', 'D', 'E', 'E', 'I', 'N', 'O', 'R', 'S', 'T', 'U', 'U', 'Y', 'Z');
    return str_replace($accents, $without, $string);
}

// Generování náhodného hesla
function generateRandomPassword($length = 8) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ!%&*()-_+=';
    $genhesl = '';
    // Jednoho velké písmeno, jedno malé písmeno, jedno číslo a jeden speciální znak
    $genhesl .= substr(str_shuffle('abcdefghijklmnopqrstuvwxyz'), 0, 1); // Malé písmeno
    $genhesl .= substr(str_shuffle('ABCDEFGHIJKLMNOPQRSTUVWXYZ'), 0, 1); // Velké písmeno
    $genhesl .= substr(str_shuffle('0123456789'), 0, 1); // Číslo
    $genhesl .= substr(str_shuffle('!%&*()-_+='), 0, 1); // Speciální znak
    // Náhodné doplnění zbylých znaků
    for ($i = 4; $i < $length; $i++) {
        $genhesl .= $characters[rand(0, strlen($characters) - 1)];
    }
    return $genhesl;
}

// Kontrola existence loginu v databázi
function loginExists($conn, $login) {
    $sql = "SELECT * FROM Prihlasovaci_udaje WHERE login = :login";
    $stmt = $conn->prepare($sql);
    $stmt->bindParam(':login', $login);
    $stmt->execute();
    return $stmt->rowCount() > 0;
}

// Vložení uživatele do databáze
function insertUser($conn, $jmeno, $prijmeni, $datumNarozeni, $telefon, $email, $psc, $ulice, $cisloPopisne, $mesto, $login, $heslo_hash, $prava) {
    try {
        // Začátek transakce
        $conn->beginTransaction();

        // Vložení adresy
        $sql = "INSERT INTO Adresa (psc, ulice, cisloPopisne, mesto) VALUES (:psc, :ulice, :cisloPopisne, :mesto)";
        $stmt = $conn->prepare($sql);
        $stmt->bindParam(':psc', $psc);
        $stmt->bindParam(':ulice', $ulice);
        $stmt->bindParam(':cisloPopisne', $cisloPopisne);
        $stmt->bindParam(':mesto', $mesto);
        $stmt->execute();

        // Získání ID vložené adresy
        $idAdresa = $conn->lastInsertId();

        // Vložení osobních údajů
        $sql = "INSERT INTO Osobni_udaje (jmeno, prijmeni, datumNarozeni, telefon, email, Adresa_idAdresa) VALUES (:jmeno, :prijmeni, :datumNarozeni, :telefon, :email, :Adresa_idAdresa)";
        $stmt = $conn->prepare($sql);
        $stmt->bindParam(':jmeno', $jmeno);
        $stmt->bindParam(':prijmeni', $prijmeni);
        $stmt->bindParam(':datumNarozeni', $datumNarozeni);
        $stmt->bindParam(':telefon', $telefon);
        $stmt->bindParam(':email', $email);
        $stmt->bindParam(':Adresa_idAdresa', $idAdresa);
        $stmt->execute();

        // Získání ID vložených osobních údajů
        $idOsobni_udaje = $conn->lastInsertId();

        // Vložení přihlašovacích údajů
        $sql = "INSERT INTO Prihlasovaci_udaje (login, heslo_hash, Prava_idPrava) VALUES (:login, :heslo_hash, :prava)";
        $stmt = $conn->prepare($sql);
        $stmt->bindParam(':login', $login);
        $stmt->bindParam(':heslo_hash', $heslo_hash);
        $stmt->bindParam(':prava', $prava);
        $stmt->execute();

        // Získání ID vložených přihlašovacích údajů
        $idPrihlasovaci_udaje = $conn->lastInsertId();

        // Vložení klienta
        $sql = "INSERT INTO Klient (ico, Osobni_udaje_idOsobni_udaje, Prihlasovaci_udaje_idPrihlasovaci_udaje) VALUES (:ico, :idOsobni_udaje, :idPrihlasovaci_udaje)";
        $stmt = $conn->prepare($sql);
        $stmt->bindParam(':ico', $ico);
        $stmt->bindParam(':idOsobni_udaje', $idOsobni_udaje);
        $stmt->bindParam(':idPrihlasovaci_udaje', $idPrihlasovaci_udaje);
        $stmt->execute();

        // Potvrzení transakce
        $conn->commit();
        return true;
    } catch (PDOException $e) {
        // Pokud dojde k chybě, zruší se transakce
        $conn->rollBack();
        echo "Chyba při vkládání uživatele: " . $e->getMessage();
        return false;
    }
}
// Kontrola odeslání formuláře
if ($_SERVER["REQUEST_METHOD"] == "POST") {
    // Zpracování formuláře
    $jmeno = trim($_POST['jmeno']);
    $prijmeni = trim($_POST['prijmeni']);
    $datumNarozeni = $_POST['datumNarozeni'];
    $telefon = trim($_POST['telefon']);
    $email = trim($_POST['email']);
    $psc = trim($_POST['psc']);
    $ulice = trim($_POST['ulice']);
    $cisloPopisne = trim($_POST['cisloPopisne']);
    $mesto = trim($_POST['mesto']);

    $errors = [];

    // Validace jména
    if (empty($jmeno)) {
        $errors['jmeno'] = "Jméno je povinné pole.";
    }

    // Validace příjmení
    if (empty($prijmeni)) {
        $errors['prijmeni'] = "Příjmení je povinné pole.";
    }

    // Validace datumu narození
    if (empty($datumNarozeni)) {
        $errors['datumNarozeni'] = "Datum narození je povinné pole.";
    }

    // Validace telefonu
    if (!preg_match("/^\d{9}$/", $telefon)) {
        $errors['telefon'] = "Telefonní číslo musí být ve formátu 123456789.";
    }

    // Validace e-mailu
    if (empty($email)) {
        $errors['email'] = "E-mailová adresa je povinný údaj.";
    } elseif (!filter_var($email, FILTER_VALIDATE_EMAIL)) {
        $errors['email'] = "Zadaná e-mailová adresa není ve správném formátu.";
    }

    // Validace PSČ
    if (empty($psc)) {
        $errors['psc'] = "PSČ je povinné pole.";
    } elseif (!preg_match("/^\d{5}$/", $psc)) {
        $errors['psc'] = "PSČ musí být pětimístné číslo.";
    }

    // Validace ulice
    if (empty($ulice)) {
        $errors['ulice'] = "Ulice je povinné pole.";
    }

    // Validace příjmení
    if (empty($cisloPopisne)) {
        $errors['cisloPopisne'] = "Číslo popisné je povinné pole.";
    }

    // Validace datumu narození
    if (empty($mesto)) {
        $errors['mesto'] = "Město je povinné pole.";
    }

    // Pokud nejsou žádné chyby, pokračuje v zpracování formuláře
    if (empty($errors)) {
        
        // Kontrola existence uživatele
        if (userExists($conn, $jmeno, $prijmeni, $datumNarozeni, $telefon, $email)) {
            echo "Uživatel již existuje.";
        } else {
            // Generování loginu a hesla
            $login = generateRandomLogin($jmeno, $prijmeni, $conn);
            $genhesl = generateRandomPassword();
            $heslo_hash = password_hash($genhesl, PASSWORD_DEFAULT);
            $prava = 3;

            // Vložení uživatele do databáze
            if (insertUser($conn, $jmeno, $prijmeni, $datumNarozeni, $telefon, $email, $psc, $ulice, $cisloPopisne, $mesto, $login, $heslo_hash, $prava)) {
                echo "Uživatel úspěšně přidán.";
 
            // Sestavení obsahu emailu
            $subject = "Přihlašovací údaje do moto aplikace";
            $message = "Dobrý den,<br>
            níže Vám zasíláme Vaše přihlašovací údaje do moto aplikace:<br><br>
            
            \nLogin: $login <br>
            \nHeslo: $genhesl <br><br>
            
            Po úspěšném přihlášení si změňte heslo.<br>
            IS moto podpora";
             
                // Odeslání emailu
                if (sendEmail($email, $subject, $message)) {
                    echo "Přihlašovací údaje byly odeslány na email.";
                    // JavaScript pro přesměrování
                    echo "<script>
                        setTimeout(function(){
                            window.location.href = 'index.php';
                        }, 3000);
                    </script>";
                } else {
                    echo "Chyba při odesílání emailu.";
                }
            } else {
                echo "Chyba při přidávání uživatele.";
            }
        }
    } else {
        // Zobrazení chyb, pokud jsou nějaké
        foreach ($errors as $error) {
            echo $error . "<br>";
        }
    }
}

?>