<?php
session_start();

$servername = '10.79.157.1:3306';
$username = 'root';
$password = '*****';
$dbname = 'moto_dilna_db';

try {
    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

    // Formulář pro přihlášení
if ($_SERVER["REQUEST_METHOD"] == "POST" && isset($_POST['prihlasit'])) {
        $login = $_POST['login'];
        $password_login = $_POST['heslo'];

        // Ověření přihlašovacích údajů
        $stmt = $conn->prepare("SELECT * FROM Prihlasovaci_udaje WHERE login = :login");
        $stmt->bindParam(':login', $login);
        $stmt->execute();

        $result = $stmt->fetch(PDO::FETCH_ASSOC);

        if ($result) {
            // Kontrola hesla pomocí password_verify()
            if (password_verify($password_login, $result['heslo_hash'])) {
                // Přihlašovací údaje jsou platné, určení úrovně přístupu
                $uroven = $result['Prava_idPrava'];
                
                // Získání ID klienta pouze pokud Prava_idPrava = 3
                if ($uroven == 3) {
                    $stmt_klient = $conn->prepare("SELECT idKlient FROM Klient WHERE Prihlasovaci_udaje_idPrihlasovaci_udaje = :id");
                    $stmt_klient->bindParam(':id', $result['idPrihlasovaci_udaje']);
                    $stmt_klient->execute();
                    $row_klient = $stmt_klient->fetch(PDO::FETCH_ASSOC);
                    $_SESSION['user_id'] = $row_klient['idKlient']; // Uložení ID klienta do relace
                }

                // Získání ID mechanika pouze pokud Prava_idPrava = 2
                if ($uroven == 2) {
                    $stmt_mecha = $conn->prepare("SELECT idMechanik FROM Mechanik WHERE Prihlasovaci_udaje_idPrihlasovaci_udaje = :id");
                    $stmt_mecha->bindParam(':id', $result['idPrihlasovaci_udaje']);
                    $stmt_mecha->execute();
                    $row_mecha = $stmt_mecha->fetch(PDO::FETCH_ASSOC);
                    $_SESSION['mechanik_id'] = $row_mecha['idMechanik']; // Uložení ID mechanika do relace
                }

                // Získání role uživatele z databáze
                $stmt_role = $conn->prepare("SELECT nazev FROM Prava WHERE idPrava = :idPrava");
                $stmt_role->bindParam(':idPrava', $uroven);
                $stmt_role->execute();
                $role_result = $stmt_role->fetch(PDO::FETCH_ASSOC);
                $role = $role_result['nazev'];

                // Uložení role do relace
                $_SESSION['role'] = $role;
                $_SESSION['loggedin'] = true;

                // Pokračování podle role uživatele
                switch ($role) {
                    case 'admin':
                    case 'mechanik':
                        header("Location: mechanik.php");
                        break;
                    case 'klient':
                        header("Location: C_Client.php");
                        break;
                    default:
                        header("Location: stranka_default.php");
                }
                
                exit; // Zajištění, že se dále neprovedou žádné kódy po přesměrování
            } else {
                echo "Neplatné přihlašovací údaje";
            }
        } else {
            echo "Neplatné přihlašovací údaje";
        }
    }
} catch(PDOException $e) {
    echo "Připojení k databázi selhalo: " . $e->getMessage();
}
?>