<?php
include 'S_security.php';
?>
<?php
session_start();

// Získání ID uživatele z relace
$mecha = $_SESSION['mechanik_id'];

// Pokud user_id není nastaveno v relaci, zobrazí se chybové hlášení
if(!isset($mecha)) {
    echo "Mecha ID není nastaveno v relaci.";
    exit();
}
?>

<!DOCTYPE html>
<html lang="cs">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Hlavní stránka</title>
  <link rel="icon" type="image/png" href="Photo.png">
  <link href="scss.css" rel="stylesheet" />
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>
<body>
  <div class="container-fluid">
    <div class="row">
      <div class="col-lg-2 col-md-3 purple-bar">
        <div class="button-container">
          <br>
          <button type="button" class="btn btn-success mb-3" onclick="window.location.href='M_Addmoto.php';"><b>Přidat motocykl</b></button>
          <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='M_Addclient.php';">Přidat uživatele</button>
          <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='M_Calendar.php';">Plánovač událostí</button>
          <button onclick="openModal()" class="btn btn-primary mb-3">Seznam kolegů</button>
          <div id="myModal" class="modal">
            <div class="modal-content">
             <span class="close" onclick="closeModal()">&times;</span>
              <?php

                $servername = '10.79.157.1:3306';
                $username = 'root';
                $password = '*****';
                $dbname = 'moto_dilna_db';

                try {
                    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
                    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

                    // Načtení jmen a příjmení těch uživatelů, kteří mají práva s hodnotou 2
                    $stmt = $conn->prepare("SELECT login FROM Prihlasovaci_udaje WHERE Prava_idPrava = 2");
                    $stmt->execute();

                    // Výpis jmen a příjmení
                    echo "<ul>";
                    while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
                    echo "<li>" . $row['login'] . "</li>";
                    }
                    echo "</ul>";

                    } catch(PDOException $e) {
                    echo "Připojení k databázi selhalo: " . $e->getMessage();
                    }
                    $conn = null;
              ?>
            </div>
          </div>
          <script> 
            // Zobrazení okna
            function openModal() {
            document.getElementById("myModal").style.display = "block";
            }
            // Zavření okna
            function closeModal() {
            document.getElementById("myModal").style.display = "none";
            }
            // zavření okna po kliknutí vedle
            window.onclick = function(event) {
            var modal = document.getElementById("myModal");
            if (event.target == modal) {
            modal.style.display = "none";
            }
            }
          </script>
          <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='M_Clientseznam.php';">Seznam klientů</button>
          <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='M_Chat.php';">Podpora</button>
        </div>
      </div>
      <div class="col-lg-8 col-md-8">
        <div class="middle-bar">
          <div class="centered-text">
            <div class="content">
              <div class="container">
                <h2>Vyhledání motocyklu:</h2>
                <form method="get" action="">
                  <input type="text" name="search" placeholder="Zadejte model motocyklu">
                  <select name="model">
                    <option value="">Vyberte model</option>
                      <?php

                      $servername = '10.79.157.1:3306';
                      $username = 'root';
                      $password = '*****';
                      $dbname = 'moto_dilna_db';

                      try {
                          $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
                          $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

                          // Načtení všech modelů motocyklů
                          $stmt = $conn->prepare("SELECT DISTINCT model FROM Motocykl");
                          $stmt->execute();

                          // Výpis všech modelů motocyklů do pole nabídky
                          while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
                              echo "<option value='" . $row['model'] . "'>" . $row['model'] . "</option>";
                          }
                      } catch(PDOException $e) {
                          echo "Připojení k databázi selhalo: " . $e->getMessage();
                      }
                      ?>
                  </select>
                  <button type="submit" class="btn btn-primary mb-3">Vyhledat</button>
                  <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='mechanik.php';">Zpět</button>            
                </form>
              </div>
              <?php

                $servername = '10.79.157.1:3306';
                $username = 'root';
                $password = '*****';
                $dbname = 'moto_dilna_db';

                try {
                    $conn = new PDO("mysql:host=$servername;dbname=$dbname", $username, $password);
                    $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);

                    // Vyhledávání podle modelu motocyklu, pokud byl odeslán formulář
                    if(isset($_GET['search']) && !empty($_GET['search'])) {
                        $search = $_GET['search'];
                        $stmt = $conn->prepare("SELECT o.jmeno, o.prijmeni, o.telefon, o.idOsobni_udaje, m.VIN, m.rokVyroby, m.model, m.foto
                                                FROM Osobni_udaje o
                                                JOIN Klient k ON o.idOsobni_udaje = k.Osobni_udaje_idOsobni_udaje
                                                JOIN Motocykl m ON k.idKlient = m.Klient_idKlient
                                                WHERE m.model LIKE :search");
                        $stmt->execute(array(':search' => '%' . $search . '%'));
                    } elseif(isset($_GET['model']) && !empty($_GET['model'])) {
                        $model = $_GET['model'];
                        $stmt = $conn->prepare("SELECT o.jmeno, o.prijmeni, o.telefon, o.idOsobni_udaje, m.VIN, m.rokVyroby, m.model, m.foto
                                                FROM Osobni_udaje o
                                                JOIN Klient k ON o.idOsobni_udaje = k.Osobni_udaje_idOsobni_udaje
                                                JOIN Motocykl m ON k.idKlient = m.Klient_idKlient
                                                WHERE m.model = :model");
                        $stmt->execute(array(':model' => $model));
                    } else {
                        // Pokud nebyl odeslán formulář, zobrazí všechny záznamy
                        $stmt = $conn->prepare("SELECT o.jmeno, o.prijmeni, o.telefon, o.idOsobni_udaje, m.VIN, m.rokVyroby, m.model, m.foto
                                                FROM Osobni_udaje o
                                                JOIN Klient k ON o.idOsobni_udaje = k.Osobni_udaje_idOsobni_udaje
                                                JOIN Motocykl m ON k.idKlient = m.Klient_idKlient");
                        $stmt->execute();
                    }

                    // Výpis tlačítek s informacemi o motocyklech a jejich majitelích
                    while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
                        echo "<button type='button' class='btn-lg mb-4 text-center' onclick=\"window.location.href='M_Motoupgrade.php?VIN=" . $row['VIN'] . "&idOsobni_udaje=" . $row['idOsobni_udaje'] . "';\">";
                        echo "<img src=" . $row['foto'] . " alt='motorcycle' width='240' height='150'>";
                        echo "<br><b>Model:</b> " . $row['model'] . "</br>";
                        echo "<b>VIN:</b> " . $row['VIN'] . "";
                        echo "<br><b>Rok výroby:</b> " . $row['rokVyroby'] . "</br>";
                        echo "<!-- idOsobni_udaje: " . $row['idOsobni_udaje'] . " -->";
                        echo "</button>";
                    }
                } catch(PDOException $e) {
                    echo "Připojení k databázi selhalo: " . $e->getMessage();
                }
                $conn = null;
                ?>
            </div>
          </div>
        </div>
      </div>
      <div class="col-lg-2 col-md-3 purple-bar">
        <div class="button-container">
          <br>
          <button type="button" class="btn btn-primary mb-3" onclick="window.location.href='mechanik.php';">Domov</button>
          <button type="button" class="btn btn-primary mb-3" onclick="openChangePasswordModal()"><b>Nastavení</b></button>
          <div id="changePasswordModal" class="modal">
              <div class="modal-content">
                   <span class="close" onclick="closeChangePasswordModal()">&times;</span>
                   <h2>Změna hesla</h2>
                  <div class="form-group">
                      <form method="post" action="S_MechPASS.php">
                          <label for="newPassword">Nové heslo:</label>
                          <input type="password" class="form-control" name="newPassword" id="newPassword" placeholder="Zadejte nové heslo">
                          <br>
                          <button type="submit" class="btn btn-primary">Uložit</button>
                      </form>
                  </div>
              </div>
          </div>
          <script>
              // Otevření vyskakovacího okna pro změnu hesla
              function openChangePasswordModal() {
                  document.getElementById("changePasswordModal").style.display = "block";
              }
              // Zavření vyskakovacího okna pro změnu hesla
              function closeChangePasswordModal() {
                  document.getElementById("changePasswordModal").style.display = "none";
              }
          </script>
            <form method="post">
             <button type="submit" name="logout" class="btn btn-danger mb-3">Odhlásit se</button>
            </form>
        </div>
      </div>
    </div>
  </div>
</body>
</html>
